module adjnull_mod
  ! One Hundred Thousend flavors of the familiar adjnull routine
  
  interface adjnull
    module procedure adjnull_real_real
    module procedure adjnull_int_real
    module procedure adjnull_real_int
    module procedure adjnull_int_int
    module procedure adjnull_real_complex
    module procedure adjnull_realm2_realm2
    module procedure adjnull_realm3_realm3
    module procedure adjnull_real_realm2
    module procedure adjnull_realm2_realm3
    module procedure adjnull_realm3_realm4
    module procedure adjnull_realm2_complexm2
    module procedure adjnull_realm3_complexm3
    module procedure adjnull_real_complexm2
    module procedure adjnull_realm2_complexm3
    module procedure adjnull_realm3_complexm4
  end interface
  
  contains
  
  subroutine adjnull_real_real( adj, add, x, y )
    logical, intent(in)      :: adj, add
    real                     ::           x(:),y(:)

    if( .not. add ) then
      if( adj ) then
        x = 0.
      else
        y = 0.
      end if
    end if
    
  end subroutine  

  
  subroutine adjnull_int_int( adj, add, x, y )
    logical, intent(in) ::    adj, add
    integer             ::              x(:), y(:)

    if( .not. add ) then
      if( adj ) then
        x = 0
      else
        y = 0
      end if
    end if

  end subroutine
  
  
  subroutine adjnull_real_int ( adj, add, x, y )
    logical, intent(in)      :: adj, add
    integer                  ::              y(:)
    real                     ::           x(:)

    if( .not. add ) then
      if( adj ) then
        x = 0.
      else
        y = 0
      end if
    end if

  end subroutine  
  
  
  subroutine adjnull_int_real ( adj, add, x, y )
    logical, intent(in)      :: adj, add
    integer                  ::           x(:)
    real                     ::              y(:)

    if( .not. add ) then
      if( adj ) then
        x = 0.
      else
        y = 0
      end if
    end if

  end subroutine
  

  subroutine adjnull_real_complex( adj, add, x, y )
    logical, intent(in)      ::    adj, add
    real                     ::              x(:)
    complex                  ::                 y(:)
    
    if( .not. add ) then
      if( adj ) then
        x = 0.
      else
        y = cmplx(0.,0.)
      end if
    end if
    
  end subroutine


  subroutine adjnull_realm2_realm2( adj, add, x, y )
    logical, intent(in)      ::   adj, add
    real                     ::             x(:,:)
    real                     ::                y(:,:)
    
    if( .not. add ) then
      if( adj ) then
        x = 0.
      else
        y = 0.
      end if
    end if
    
  end subroutine  

  subroutine adjnull_realm3_realm3( adj, add, x, y )
    logical, intent(in)      ::   adj, add
    real                     ::             x(:,:,:)
    real                     ::                y(:,:,:)
    
    if( .not. add ) then
      if( adj ) then
        x = 0.
      else
        y = 0.
      end if
    end if
    
  end subroutine  


  
  subroutine adjnull_realm2_complexm2( adj, add, x, y )
    logical, intent(in)      ::     adj, add
    real                     ::               x(:,:)
    complex                  ::                  y(:,:)
    
    if( .not. add ) then
      if( adj ) then
        x = 0.
      else
        y = cmplx(0.,0.)
      end if
    end if
    
  end subroutine  



  subroutine adjnull_realm3_complexm3( adj, add, x, y )
    logical, intent(in)      ::     adj, add
    real                     ::               x(:,:,:)
    complex                  ::                  y(:,:,:)
    
    if( .not. add ) then
      if( adj ) then
        x = 0.
      else
        y = cmplx(0.,0.)
      end if
    end if
    
  end subroutine  



  subroutine adjnull_real_complexm2( adj, add, x, y )
    logical, intent(in)      ::     adj, add
    real                     ::               x(:)
    complex                  ::                  y(:,:)
    
    if( .not. add ) then
      if( adj ) then
        x = 0.
      else
        y = cmplx(0.,0.)
      end if
    end if
    
  end subroutine  


  subroutine adjnull_realm2_complexm3( adj, add, x, y )
    logical, intent(in)      ::     adj, add
    real                     ::               x(:,:)
    complex                  ::                  y(:,:,:)
    
    if( .not. add ) then
      if( adj ) then
        x = 0.
      else
        y = cmplx(0.,0.)
      end if
    end if
    
  end subroutine  


  subroutine adjnull_realm3_complexm4( adj, add, x, y )
    logical, intent(in)      ::     adj, add
    real                     ::               x(:,:,:)
    complex                  ::                  y(:,:,:,:)
    
    if( .not. add ) then
      if( adj ) then
        x = 0.
      else
        y = cmplx(0.,0.)
      end if
    end if
    
  end subroutine  


  subroutine adjnull_real_realm2( adj, add, x, y )
    logical, intent(in)      ::     adj, add
    real                     ::               x(:),y(:,:)

    if( .not. add ) then
      if( adj ) then
        x = 0.
      else
        y = cmplx(0.,0.)
      end if
    end if
    
  end subroutine  


  subroutine adjnull_realm2_realm3( adj, add, x, y )
    logical, intent(in)      ::     adj, add
    real                     ::               x(:,:),y(:,:,:)

    if( .not. add ) then
      if( adj ) then
        x = 0.
      else
        y = cmplx(0.,0.)
      end if
    end if
    
  end subroutine  


  subroutine adjnull_realm3_realm4( adj, add, x, y )
    logical, intent(in)      ::     adj, add
    real                     ::               x(:,:,:),y(:,:,:,:)

    if( .not. add ) then
      if( adj ) then
        x = 0.
      else
        y = cmplx(0.,0.)
      end if
    end if
    
  end subroutine  


end module
