module bitprinting_mod
  ! Print routines for bit representation of integers and integer arrays
  ! Print values stored in integers and integer arrays
  ! No initialization needed:
  ! Usage:
  ! call printbits(int_variable)

  interface printbits
   module procedure printbits_array1
   module procedure printbits_array2
   module procedure printbits_array4
   module procedure printbits_array8
   module procedure printbits_single1
   module procedure printbits_single2
   module procedure printbits_single4
   module procedure printbits_single8
  end interface

  interface printdata
   module procedure printdata_array1
   module procedure printdata_array2
   module procedure printdata_array4
   module procedure printdata_array8
   module procedure printdata_single1
   module procedure printdata_single2
   module procedure printdata_single4
   module procedure printdata_single8
  end interface

  contains

  subroutine printbits_array1(datain)
    integer*1,intent(in)   :: datain(:)
    integer              :: pos, nbit, ii,y
    
    ! Print Bits
    nbit = bit_size(datain(1))
    do ii=1,size(datain)
      y = datain(ii)
      do pos=nbit-1,0,-1
        if ( btest(y,pos) ) then
          write(0,'(I1)', advance='no'), 1
        else
          write(0,'(I1)', advance='no'), 0
        end if

        if (modulo(pos,4).eq.0 .and. pos.ne.0) then
          write(0,'(A1)', advance='no') ' '
        end if
      
      end do
      if (ii.ne.size(datain)) then
        write(0,'(A1)', advance='yes') ' '
      end if
    end do
   write(0,*) ''

  end subroutine

  subroutine printbits_array2(datain)
    integer*2,intent(in)   :: datain(:)
    integer              :: pos, nbit, ii,y
    
    ! Print Bits
    nbit = bit_size(datain(1))
    do ii=1,size(datain)
      y = datain(ii)
      do pos=nbit-1,0,-1
        if ( btest(y,pos) ) then
          write(0,'(I1)', advance='no'), 1
        else
          write(0,'(I1)', advance='no'), 0
        end if

        if (modulo(pos,4).eq.0 .and. pos.ne.0) then
          write(0,'(A1)', advance='no') ' '
        end if
      
      end do
      if (ii.ne.size(datain)) then
        write(0,'(A1)', advance='yes') ' '
      end if
    end do
   write(0,*) ''

  end subroutine

  subroutine printbits_array4(datain)
    integer*4,intent(in)   :: datain(:)
    integer              :: pos, nbit, ii,y
    
    ! Print Bits
    nbit = bit_size(datain(1))
    do ii=1,size(datain)
      y = datain(ii)
      do pos=nbit-1,0,-1
        if ( btest(y,pos) ) then
          write(0,'(I1)', advance='no'), 1
        else
          write(0,'(I1)', advance='no'), 0
        end if

        if (modulo(pos,4).eq.0 .and. pos.ne.0) then
          write(0,'(A1)', advance='no') ' '
        end if
      
      end do
      if (ii.ne.size(datain)) then
        write(0,'(A1)', advance='yes') ' '
      end if
    end do
   write(0,*) ''

  end subroutine

  subroutine printbits_array8(datain)
    integer*8,intent(in)   :: datain(:)
    integer              :: pos, nbit, ii,y
    
    ! Print Bits
    nbit = bit_size(datain(1))
    do ii=1,size(datain)
      y = datain(ii)
      do pos=nbit-1,0,-1
        if ( btest(y,pos) ) then
          write(0,'(I1)', advance='no'), 1
        else
          write(0,'(I1)', advance='no'), 0
        end if

        if (modulo(pos,4).eq.0 .and. pos.ne.0) then
          write(0,'(A1)', advance='no') ' '
        end if
      
      end do
      if (ii.ne.size(datain)) then
        write(0,'(A1)', advance='yes') ' '
      end if
    end do
   write(0,*) ''

  end subroutine







  subroutine printbits_single1(datain)
    integer*1,intent(in)   :: datain
    integer              :: pos, nbit, ii,y
    
    ! Print Bits
    nbit = bit_size(datain)
    y = datain
    do pos=nbit-1,0,-1
      if ( btest(y,pos) ) then
        write(0,'(I1)', advance='no'), 1
      else
        write(0,'(I1)', advance='no'), 0
      end if

      if (modulo(pos,4).eq.0 .and. pos.ne.0) then
        write(0,'(A1)', advance='no') ' '
      end if
      
    end do
 
    write(0,*) ''

  end subroutine

  subroutine printbits_single2(datain)
    integer*2,intent(in)   :: datain
    integer              :: pos, nbit, ii,y
    
    ! Print Bits
    nbit = bit_size(datain)
    y = datain
    do pos=nbit-1,0,-1
      if ( btest(y,pos) ) then
        write(0,'(I1)', advance='no'), 1
      else
        write(0,'(I1)', advance='no'), 0
      end if

      if (modulo(pos,4).eq.0 .and. pos.ne.0) then
        write(0,'(A1)', advance='no') ' '
      end if
      
    end do
 
    write(0,*) ''

  end subroutine

  subroutine printbits_single4(datain)
    integer*4,intent(in)   :: datain
    integer              :: pos, nbit, ii,y
    
    ! Print Bits
    nbit = bit_size(datain)
    y = datain
    do pos=nbit-1,0,-1
      if ( btest(y,pos) ) then
        write(0,'(I1)', advance='no'), 1
      else
        write(0,'(I1)', advance='no'), 0
      end if

      if (modulo(pos,4).eq.0 .and. pos.ne.0) then
        write(0,'(A1)', advance='no') ' '
      end if
      
    end do
 
    write(0,*) ''

  end subroutine

  subroutine printbits_single8(datain)
    integer*8,intent(in)   :: datain
    integer              :: pos, nbit, ii,y
    
    ! Print Bits
    nbit = bit_size(datain)
    y = datain
    do pos=nbit-1,0,-1
      if ( btest(y,pos) ) then
        write(0,'(I1)', advance='no'), 1
      else
        write(0,'(I1)', advance='no'), 0
      end if

      if (modulo(pos,4).eq.0 .and. pos.ne.0) then
        write(0,'(A1)', advance='no') ' '
      end if
      
    end do
 
    write(0,*) ''

  end subroutine








  subroutine printdata_array1(datain)
    integer*1,intent(in)   :: datain(:)
    integer              :: ii
    
    ! Print Data
    do ii=1,size(datain)
      write(0,'(I11)', advance='no')  datain(ii)
      write(0,'(A1)', advance='no') ' '
    end do
   write(0,*) ''

  end subroutine

  subroutine printdata_array2(datain)
    integer*2,intent(in)   :: datain(:)
    integer              :: ii
    
    ! Print Data
    do ii=1,size(datain)
      write(0,'(I11)', advance='no')  datain(ii)
      write(0,'(A1)' , advance='no') ' '
    end do
   write(0,*) ''

  end subroutine

  subroutine printdata_array4(datain)
    integer*4,intent(in)   :: datain(:)
    integer                :: ii
    
    ! Print Data
    do ii=1,size(datain)
      write(0,'(I11)', advance='no')  datain(ii)
      write(0,'(A1)', advance='no') ' '
    end do
   write(0,*) ''

  end subroutine

  subroutine printdata_array8(datain)
    integer*8,intent(in)   :: datain(:)
    integer              :: ii
    
    ! Print Data
    do ii=1,size(datain)
      write(0,'(I11)', advance='no')  datain(ii)
      write(0,'(A1)' , advance='no') ' '
    end do
   write(0,*) ''

  end subroutine
 

  subroutine printdata_single1(datain)
    integer*1,intent(in)   :: datain
    integer              :: ii
    
    ! Print Data
    write(0,'(I11)', advance='no')  datain
    write(0,'(A1)' , advance='no') ' '
    write(0,*) ''

  end subroutine


  subroutine printdata_single2(datain)
    integer*2,intent(in)   :: datain
    integer              :: ii
    
    ! Print Data
    write(0,'(I11)', advance='no')  datain
    write(0,'(A1)' , advance='no') ' '
    write(0,*) ''

  end subroutine

  subroutine printdata_single4(datain)
    integer*4,intent(in)   :: datain
    integer              :: ii
    
    ! Print Data
    write(0,'(I11)', advance='no')  datain
    write(0,'(A1)' , advance='no') ' '
    write(0,*) ''

  end subroutine

  subroutine printdata_single8(datain)
    integer*8,intent(in)   :: datain
    integer              :: ii
    
    ! Print Data
    write(0,'(I11)', advance='no')  datain
    write(0,'(A1)' , advance='no') ' '
    write(0,*) ''

  end subroutine

end module
