 

  subroutine fftshift2d_real_real_12_2d(adj,add,m,d)
    logical, intent(in)      :: adj,add
    real                     :: m(:,:),d(:,:)
    integer                  :: n1,n2
    
    call                adjnull(adj,add,m,d)
    n1 = size(m,1)
    n2 = size(m,2)
    if ( adj ) then
      m(      1:n1/2 ,      1:n2/2 ) = d( n1/2+1:n1   ,n2/2+1:n2   )
      m( n1/2+1:n1   ,      1:n2/2 ) = d(      1:n1/2 ,n2/2+1:n2   )
      m(      1:n1/2 , n2/2+1:n2   ) = d( n1/2+1:n1   ,     1:n2/2 )
      m( n1/2+1:n1   , n2/2+1:n2   ) = d(      1:n1/2 ,     1:n2/2 )
    else
      d(      1:n1/2 ,      1:n2/2 ) = m( n1/2+1:n1   ,n2/2+1:n2  ) 
      d( n1/2+1:n1   ,      1:n2/2 ) = m(      1:n1/2 ,n2/2+1:n2   )
      d(      1:n1/2 , n2/2+1:n2   ) = m( n1/2+1:n1   ,     1:n2/2 )
      d( n1/2+1:n1   , n2/2+1:n2   ) = m(      1:n1/2 ,     1:n2/2 )
    end if
    
  end subroutine



  subroutine fftshift2d_real_real_12_3d(adj,add,m,d)
    logical, intent(in)      :: adj,add
    real                     :: m(:,:,:),d(:,:,:)
    integer                  :: n1,n2
    
    call                adjnull(adj,add,m,d)
    n1 = size(m,1)
    n2 = size(m,2)
    if ( adj ) then
      m(      1:n1/2 ,      1:n2/2 , : ) = d( n1/2+1:n1   ,n2/2+1:n2   , : )
      m( n1/2+1:n1   ,      1:n2/2 , : ) = d(      1:n1/2 ,n2/2+1:n2   , : )
      m(      1:n1/2 , n2/2+1:n2   , : ) = d( n1/2+1:n1   ,     1:n2/2 , : )
      m( n1/2+1:n1   , n2/2+1:n2   , : ) = d(      1:n1/2 ,     1:n2/2 , : )
    else
      d(      1:n1/2 ,      1:n2/2 , : ) = m( n1/2+1:n1   ,n2/2+1:n2   , : )
      d( n1/2+1:n1   ,      1:n2/2 , : ) = m(      1:n1/2 ,n2/2+1:n2   , : )
      d(      1:n1/2 , n2/2+1:n2   , : ) = m( n1/2+1:n1   ,     1:n2/2 , : )
      d( n1/2+1:n1   , n2/2+1:n2   , : ) = m(      1:n1/2 ,     1:n2/2 , : )
    end if
    
  end subroutine



  subroutine fftshift2d_real_real_23_3d(adj,add,m,d)
    logical, intent(in)      :: adj,add
    real                     :: m(:,:,:),d(:,:,:)
    integer                  :: n2,n3
    
    call                adjnull(adj,add,m,d)
    n2 = size(m,2)
    n3 = size(m,3)
    if ( adj ) then
      m( :,      1:n2/2 ,      1:n3/2 ) = d( :, n2/2+1:n2   , n3/2+1:n3   )
      m( :, n2/2+1:n2   ,      1:n3/2 ) = d( :,      1:n2/2 , n3/2+1:n3   )
      m( :,      1:n2/2 , n3/2+1:n3   ) = d( :, n2/2+1:n2   ,      1:n3/2 )
      m( :, n2/2+1:n2   , n3/2+1:n3   ) = d( :,      1:n2/2 ,      1:n3/2 )
    else
      d( :,      1:n2/2 ,      1:n3/2 ) = m( :, n2/2+1:n2   , n2/2+1:n3   ) 
      d( :, n2/2+1:n2   ,      1:n3/2 ) = m( :,      1:n2/2 , n2/2+1:n3   )
      d( :,      1:n2/2 , n3/2+1:n3   ) = m( :, n2/2+1:n2   ,      1:n3/2 )
      d( :, n2/2+1:n2   , n3/2+1:n3   ) = m( :,      1:n2/2 ,      1:n3/2 )
    end if
    
  end subroutine



  subroutine fftshift2d_real_real_13_3d(adj,add,m,d)
    logical, intent(in)      :: adj,add
    real                     :: m(:,:,:),d(:,:,:)
    integer                  :: n1,n3
    
    call                adjnull(adj,add,m,d)
    n1 = size(m,1)
    n3 = size(m,3)
    if ( adj ) then
      m(      1:n1/2 , : ,      1:n3/2 ) = d( n1/2+1:n1   , : , n3/2+1:n3   )
      m( n1/2+1:n1   , : ,      1:n3/2 ) = d(      1:n1/2 , : , n3/2+1:n3   )
      m(      1:n1/2 , : , n3/2+1:n3   ) = d( n1/2+1:n1   , : ,      1:n3/2 )
      m( n1/2+1:n1   , : , n3/2+1:n3   ) = d(      1:n1/2 , : ,      1:n3/2 )
    else
      d(      1:n1/2 , : ,      1:n3/2 ) = m( n1/2+1:n1   , : , n3/2+1:n3   ) 
      d( n1/2+1:n1   , : ,      1:n3/2 ) = m(      1:n1/2 , : , n3/2+1:n3   )
      d(      1:n1/2 , : , n3/2+1:n3   ) = m( n1/2+1:n1   , : ,      1:n3/2 )
      d( n1/2+1:n1   , : , n3/2+1:n3   ) = m(      1:n1/2 , : ,      1:n3/2 )
    end if
    
  end subroutine
