module random_mod
  ! Random numbers spanning: <-.5 .5>

  implicit none

  interface random_op
    module procedure random1d_op
    module procedure random2d_op
    module procedure random3d_op
    module procedure random4d_op
  end interface


  contains

  subroutine random_init  (seed_in)
    integer, optional  ::  seed_in
    integer            ::  seed(2)

    if (present(seed_in)) then
      seed(1) = seed_in;
      seed(2) = seed_in;
    else;
      call system_clock(seed(1),seed(2))
     ! seed = sum ( SYSTEM_CLOCK(COUNT, COUNT_RATE, COUNT_MAX) )
    end if
    
    call random_seed(put=seed)
  
  end subroutine


  subroutine random_close()

  end subroutine


  subroutine random1d_op(array)
    real, intent(inout) :: array(:)

    call random_number(array)
    array = array -.5

  end subroutine


  subroutine random2d_op(array)
    real, intent(inout) :: array(:,:)

    call random_number(array)
    array = array -.5

  end subroutine


  subroutine random3d_op(array)
    real, intent(inout) :: array(:,:,:)

    call random_number(array)
    array = array -.5

  end subroutine

end module
