module signbit_mod
  implicit none

  interface signbit_op

    module procedure signbit_op1d
    module procedure signbit_op2d
    module procedure signbit_op3d

  end interface

  contains

  subroutine signbit_op1d(array)
    real,intent(inout) :: array(:)

    where    (array>0.)
      array =  1.
    elsewhere(array<0.)
      array = -1.
    end where

  end subroutine


  subroutine signbit_op2d(array)
    real,intent(inout) :: array(:,:)

    where    (array>0.)
      array =  1.
    elsewhere(array<0.)
      array = -1.
    end where

  end subroutine


  subroutine signbit_op3d(array)
    real,intent(inout) :: array(:,:,:)

    where    (array>0.)
      array =  1.
    elsewhere(array<0.)
      array = -1.
    end where

  end subroutine


end module
