% Include sepatlab in path
path('/homes/sep/sjoerd/lib/sepmatlab',path);

% Read SEP-format data
disp = load_data(load_history(file_in));

ff = disp.o(1)+[0:disp.n(1)-1]*disp.d(1);
tt = disp.o(2)+[0:disp.n(2)-1]*disp.d(2);

FS = 10;
fig=figure('visible','off');
h=subplot(3,1,1); set(h,'Units','normalized','Position',[.15 .15 .19357 .5]);
%fig=figure(); %'visible','off');


pcolor(tt,ff,disp.data); shading interp;
ylabel('frequency (Hz)','FontSize',FS,'FontName','Times','FontWeight','bold');
xlabel('UT (hrs) on October 4^{th}, 2008','FontSize',FS,'FontName','Times','FontWeight','bold');
set(gcf,'PaperPositionMode','auto');
caxis([-80 80]);


%set(gca,'YScale','log','YTick',[0 0.0001 0.0002 0.0003 0.0004 0.0005 0.0006 0.0007 0.0008 0.0009 0.001 0.002 0.003 0.004 0.005 0.006]);
set(gca,'YScale','log','YDir','Reverse');
set(gca,'YTick',[0.105 1 10 100],'YTickLabel',{'0.1','1','10','100'});
set(gca,'XScale','log','XTick',[15 16]);
set(gca,'XTickLabel',{'15','16'});
axis([14.6042 16.56 .1 125]);
%set(gca,'Fontsize',FS,'FontWeight','bold');

hold on;
plot([14,17],[.1 .1],'Color','k');
plot([14,17],[ 1  1],'Color','k');
plot([14,17],[10 10],'Color','k');
plot([14,17],[100 100],'Color','k');
plot([15,15],[.1 1000],'Color','k');
plot([15.5,15.5],[.1 1000],'Color','k');
plot([16,16],[.1 1000],'Color','k');
plot([16.5,16.5],[.1 1000],'Color','k');

fillpage(fig, 'margins', [0 0 0 0], 'papersize', [9 6]);
print(gcf, '-depsc2','-r600', file_out)
