#! /usr/bin/python
import string
import shutil
import commands
import sys
import os
import glob
from array import array
from optparse import OptionParser

# Get and seperate options from arguments
parser = OptionParser()
parser.add_option("--title"   , dest="title"   , help="figure title", metavar="FOLDER")
parser.add_option("--barlabel", dest="barlabel", help="bar label"   , metavar="FOLDER")
parser.add_option("--barunit" , dest="barunit" , help="bar unit"    , metavar="FOLDER")

parser.add_option("--in" , dest="infile" , help="in file" , metavar="FOLDER")
parser.add_option("--out", dest="otfile" , help="ot file" , metavar="FOLDER")
parser.add_option("--xy" , dest="xyfile" , help="xy file" , metavar="FOLDER")
parser.add_option("--xkey" , dest="xkey" , help="x coordinate key in hff file" , metavar="FOLDER")
parser.add_option("--ykey" , dest="ykey" , help="y coordinate key in hff file" , metavar="FOLDER")

parser.add_option("--bclip" , dest="bclip"  , help="lower clip"        , metavar="FOLDER")
parser.add_option("--eclip" , dest="eclip"  , help="end clip"          , metavar="FOLDER")
parser.add_option("--barmin", dest="barmin" , help="color bar minimum" , metavar="FOLDER")
parser.add_option("--barmax", dest="barmax" , help="color bar maximum" , metavar="FOLDER")

parser.add_option("--xyunit", dest="xyunit" , help="scalefactor on XY coordinates", metavar="FOLDER")

parser.add_option("--scalebar", dest="scalebar", help="want scalebar (y/n)", metavar="FOLDER")

parser.add_option("--format", dest="format", help="output format", metavar="FOLDER")

(options, args) = parser.parse_args()

# If not supplied get default from environment, or just store locally

if options.infile==None: print "Need In file (--in)"
if options.otfile==None: print "Need Out file (--out)"
if options.xyfile==None:
  try:
    hff=str(commands.getoutput('Get <'+str(options.infile)+' hff parform=n').rstrip().lstrip())
  except:
    hff='-1'
  if os.path.isfile(hff):
    options.xyfile=hff
  else:
    print hff
if options.xkey==None: options.xkey=1
if options.ykey==None: options.ykey=2

if options.bclip==None: print "Need lower clip (--bclip)"
if options.eclip==None: print "Need lower clip (--eclip)"

if options.barmin==None: options.barmin=options.bclip
if options.barmax==None: options.barmax=options.eclip

if options.barlabel==None: options.barlabel="' '"
if options.barunit==None: options.barunit="' '"

if options.format==None: options.format='vplot'

infile = str(options.infile)
xyfile = str(options.xyfile)
bclip  = str(options.bclip)
eclip  = str(options.eclip)
barmin = str(options.barmin)
barmax = str(options.barmax)
if options.format=='ps':
  otfile = str(options.otfile)
  ovfile = str(options.otfile)+'.v'
else:
  ovfile = str(options.otfile)
xyunit = str(options.xyunit)

#mfile  = str(sys.argv[8]) 
mfile  = infile.split('.')[0]+'.movie'

bias = (float(eclip)+float(bclip))/2.
clip = (float(eclip)-float(bclip))/2.

#print clip,bias

try:
   nframes=int(commands.getoutput('Get <'+str(infile)+' n1 parform=n').rstrip().lstrip())
except:
   nframes=1
try:
   dframes=float(commands.getoutput('Get <'+str(infile)+' d1 parform=n').rstrip().lstrip())
except:
   dframes=0.
try:
   oframes=float(commands.getoutput('Get <'+str(infile)+' o1 parform=n').rstrip().lstrip())
except:
   oframes=0.


if str(options.scalebar)=='y':
  MGRID = " min1=521 max1=530 min2=6231 max2=6242 grid=1 d1num=2 d2num=2 g1num=2 g2num=2 o1num=522 n1tic=5 title=' ' label1='UTM easting' label2='UTM northing' unit1='km' unit2='km' axisfat=2 labelfat=2 xll=5 yll=1.4  xinch=7.29  yinch=7.5 scalebar="+str(options.scalebar)+" barlabel='"+str(options.barlabel)+"' barunit='"+str(options.barunit)+"' wantframenum=n"
else:
  MGRID = " min1=521 max1=530 min2=6231 max2=6242 grid=1 d1num=2 d2num=2 g1num=2 g2num=2 o1num=522 n1tic=5 title=' ' label1='UTM easting' label2='UTM northing' unit1='km' unit2='km' axisfat=2 labelfat=2 xll=5 yll=1.4  xinch=6.175 yinch=7.5 scalebar="+str(options.scalebar)+" barlabel='"+str(options.barlabel)+"' barunit='"+str(options.barunit)+"' wantframenum=n"

#print "Window <"+str(xyfile)+" n1=1 f1="+str(int(options.xkey)-1)+" | Scale rscale="+xyunit+" | Pad extend=1 n3out="+str(nframes)+" > x.x; sfdd < x.x form=native > x.X"
#print "Window <"+str(xyfile)+" n1=1 f1="+str(int(options.ykey)-1)+" | Scale rscale="+xyunit+" | Pad extend=1 n3out="+str(nframes)+" > y.y; sfdd < y.y form=native > y.Y"
#print "sfcmplx x.X y.Y > xy.XY"
#print "echo 'd3="+str(dframes)+" o3="+str(oframes)+"' >>xy.XY"
#print "cp "+str(infile)+" c.cc"
#print "echo 'hff=-1' >>c.cc"
#print "sdrTweak.x < c.cc minvalue="+str(barmin)+" maxvalue="+str(barmax)+" > c.c"
#print "sftransp <c.c plane=12 | sfdd form=native > c.cc"
#print "echo 'n2=1 n3="+str(nframes)+"' >> c.cc"
#print "sfbyte < c.cc bias="+str(bias)+" clip="+str(clip)+" bar=cbar pclip=100 > c.C"
#print "sfgraph < xy.XY depth=c.C symbol=. color=j title=' ' "+str(MGRID)+" symbolsz=9 plotfat=22 backcol=1 bias="+str(bias)+" clip="+str(clip)+" minval="+str(barmin)+" maxval="+str(barmax)+" >"+str(otfile)
commands.getoutput("Window <"+str(xyfile)+" n1=1 f1="+str(int(options.xkey)-1)+" | Scale rscale="+xyunit+" | Pad extend=1 n3out="+str(nframes)+" > x.x; sfdd < x.x form=native > x.X")
commands.getoutput("Window <"+str(xyfile)+" n1=1 f1="+str(int(options.ykey)-1)+" | Scale rscale="+xyunit+" | Pad extend=1 n3out="+str(nframes)+" > y.y; sfdd < y.y form=native > y.Y")
commands.getoutput("sfcmplx x.X y.Y > xy.XY")
commands.getoutput("echo 'd3="+str(dframes)+" o3="+str(oframes)+"' >>xy.XY")
commands.getoutput("cp "+str(infile)+" c.c")
commands.getoutput("echo 'hff=-1' >>c.c")

#commands.getoutput("sdrTweak.x < c.cc minvalue="+str(barmin)+" maxvalue="+str(barmax)+" > c.c")
commands.getoutput("sftransp <c.c plane=12 | sfdd form=native > c.cc")
commands.getoutput("echo 'n2=1 n3="+str(nframes)+"' >> c.cc")
commands.getoutput("sfbyte < c.cc bias="+str(bias)+" clip="+str(clip)+" minval="+str(barmin)+" maxval="+str(barmax)+" bar=cbar pclip=100 > c.C")
commands.getoutput("sfgraph < xy.XY depth=c.C symbol=. color=j title=' ' "+str(MGRID)+" symbolsz=9 gridfat=2 plotfat=26 backcol=1 bias="+str(bias)+" clip="+str(clip)+" minval="+str(barmin)+" maxval="+str(barmax)+" >"+str(ovfile))


if options.format=='ps':
  print "/net/server/sjoerd/RSF/bin/pspen "+str(ovfile)+" color=1 force=y forcebw=y >"+str(otfile)
  commands.getoutput("/net/server/sjoerd/RSF/bin/pspen "+str(ovfile)+" color=1 force=y forcebw=y >"+str(otfile))

