program SuperStack
  ! Program to stack mute out specific receiver=source indices,
  ! For post processing and fine tunning of SI gathers
  
  use sep
  implicit none
  
  integer                             :: n1,n2,n3
  real                                :: o1,o2,o3,d1,d2,d3
  integer                             :: ii,jj,kk

  real,allocatable,dimension(:,:)     :: datain
  integer                             :: ik,nkill
  integer,allocatable,dimension(:)    :: kill
  
  call sep_init()

  call from_history('n1',n1 ,1 )
  call from_history('n2',n2 ,1 )
  call from_history('n3',n3 ,1 )

  call from_param("nkill",nkill,0)
  allocate(kill(nkill+1))
  kill = 0
  call from_param("kill",kill,kill)
  kill(nkill+1) = 0
  
  call sep_close()
  
  allocate(datain(n1,n2)); datain  = 0.
  
  
  ! For each shot
  do kk=1,n3

    call sreed('in', datain,4*n1*n2)

    do ik=1,nkill
      datain(:,kill(ik))=0.
      if (kill(ik).eq.kk) datain=0.
    end do
    
    call srite('out',datain,4*n1*n2)

  end do
  
  
  ! Deallocate and close
  deallocate(datain)
  deallocate(kill  )
  call exit(0)
  
end program
