program SuperStack
  ! Program to stack results of Seismic Interferomery in time domain.
  ! Maximum input is 41 files (no coincidence).
  
  use sep
  implicit none
  
  integer                             :: n1,n2,n3,ne,nr,ns,esize
  real                                :: o1,o2,o3,d1,d2,d3,d4
  integer                             :: jr,js,fr,fs
  integer                             :: it,ir,is

  integer                             :: ne1 ,ne2 ,ne3 ,ne4 ,ne5
  integer                             :: ne6 ,ne7 ,ne8 ,ne9 ,ne10
  integer                             :: ne11,ne12,ne13,ne14,ne15
  integer                             :: ne16,ne17,ne18,ne19,ne20
  integer                             :: ne21,ne22,ne23,ne24,ne25
  integer                             :: ne26,ne27,ne28,ne29,ne30
  integer                             :: ne31,ne32,ne33,ne34,ne35
  integer                             :: ne36,ne37,ne38,ne39,ne40
  integer                             :: ne41,ind
  
  real,allocatable,dimension(:,:,:)   :: datain
  real,allocatable,dimension(:,:  )   :: mean
  integer                             :: ik,nkill
  integer,allocatable,dimension(:)    :: kill
  
  logical                             :: scale
  
  call sep_init()
  
  call from_param('scale',scale,.true.)
  
  call from_aux('file1','n1',n1 ,1 )
  call from_aux('file1','n2',n2 ,1 )
  call from_aux('file1','n3',n3 ,1 )
  call from_aux('file1','n4',ne1,1 )
  
  call from_aux('file1','d1',d1 ,1.)
  call from_aux('file1','d2',d2 ,1.)
  call from_aux('file1','d3',d3 ,1.)
  
  call from_aux('file1','o1',o1 ,0.)
  call from_aux('file1','o2',o2 ,0.)
  call from_aux('file1','o3',o3 ,0.)
  
  call from_param("nkill",nkill,0)
  allocate(kill(nkill+1))
  kill = 0
  call from_param("kill",kill,kill)
  kill(nkill+1) = 0

  ne41=0; ne2 =0; ne3 =0; ne4 =0; ne5 =0; ne6 =0; ne7 =0; ne8 =0; ne9 =0; ne10=0;
  ne11=0; ne12=0; ne13=0; ne14=0; ne15=0; ne16=0; ne17=0; ne18=0; ne19=0; ne20=0;
  ne21=0; ne22=0; ne23=0; ne24=0; ne25=0; ne26=0; ne27=0; ne28=0; ne29=0; ne30=0;
  ne31=0; ne32=0; ne33=0; ne34=0; ne35=0; ne36=0; ne37=0; ne38=0; ne39=0; ne40=0; ne41=0
  
  if (exist_file('file2' )) call from_aux('file2','n4',ne2,1 )
  if (exist_file('file3' )) call from_aux('file3','n4',ne3,1 )
  if (exist_file('file4' )) call from_aux('file4','n4',ne4,1 )
  if (exist_file('file5' )) call from_aux('file5','n4',ne5,1 )
  
  if (exist_file('file6' )) call from_aux('file6' ,'n4',ne6 ,1 )
  if (exist_file('file7' )) call from_aux('file7' ,'n4',ne7 ,1 )
  if (exist_file('file8' )) call from_aux('file8' ,'n4',ne8 ,1 )
  if (exist_file('file9' )) call from_aux('file9' ,'n4',ne9 ,1 )
  if (exist_file('file10')) call from_aux('file10','n4',ne10,1 )
  
  if (exist_file('file11')) call from_aux('file11','n4',ne11,1 )
  if (exist_file('file12')) call from_aux('file12','n4',ne12,1 )
  if (exist_file('file13')) call from_aux('file13','n4',ne13,1 )
  if (exist_file('file14')) call from_aux('file14','n4',ne14,1 )
  if (exist_file('file15')) call from_aux('file15','n4',ne15,1 )
  
  if (exist_file('file16')) call from_aux('file16','n4',ne16,1 )
  if (exist_file('file17')) call from_aux('file17','n4',ne17,1 )
  if (exist_file('file18')) call from_aux('file18','n4',ne18,1 )
  if (exist_file('file19')) call from_aux('file19','n4',ne19,1 )
  if (exist_file('file20')) call from_aux('file20','n4',ne20,1 )
  
  if (exist_file('file21')) call from_aux('file21','n4',ne21,1 )
  if (exist_file('file22')) call from_aux('file22','n4',ne22,1 )
  if (exist_file('file23')) call from_aux('file23','n4',ne23,1 )
  if (exist_file('file24')) call from_aux('file24','n4',ne24,1 )
  if (exist_file('file25')) call from_aux('file25','n4',ne25,1 )
  
  if (exist_file('file26')) call from_aux('file26','n4',ne26,1 )
  if (exist_file('file27')) call from_aux('file27','n4',ne27,1 )
  if (exist_file('file28')) call from_aux('file28','n4',ne28,1 )
  if (exist_file('file29')) call from_aux('file29','n4',ne29,1 )
  if (exist_file('file30')) call from_aux('file30','n4',ne30,1 )
  
  if (exist_file('file31')) call from_aux('file31','n4',ne31,1 )
  if (exist_file('file32')) call from_aux('file32','n4',ne32,1 )
  if (exist_file('file33')) call from_aux('file33','n4',ne33,1 )
  if (exist_file('file34')) call from_aux('file34','n4',ne34,1 )
  if (exist_file('file35')) call from_aux('file35','n4',ne35,1 )
  
  if (exist_file('file36')) call from_aux('file36','n4',ne36,1 )
  if (exist_file('file37')) call from_aux('file37','n4',ne37,1 )
  if (exist_file('file38')) call from_aux('file38','n4',ne38,1 )
  if (exist_file('file39')) call from_aux('file39','n4',ne39,1 )
  if (exist_file('file40')) call from_aux('file40','n4',ne40,1 )
  
  if (exist_file('file41')) call from_aux('file41','n4',ne41,1 )
  
  ne=ne1 +ne2 +ne3 +ne4 +ne5 +ne6 +ne7 +ne8 +ne9 +ne10+ &
     ne11+ne12+ne13+ne14+ne15+ne16+ne17+ne18+ne19+ne20+ &
     ne21+ne22+ne23+ne24+ne25+ne26+ne27+ne28+ne29+ne30+ &
     ne31+ne32+ne33+ne34+ne35+ne36+ne37+ne38+ne39+ne40+ne41

  write(0,*) "detected number of estimates:",ne

  call from_aux('file1','esize',esize,4)
  if (esize.ne.4) call erexit('esize.ne.4')
  
  
  call from_param('fr',fr,0 )
  call from_param('jr',jr,1 )
  call from_param('nr',nr,(n2-fr)/jr)

  call from_param('fs',fs,0 )
  call from_param('js',js,1 )
  call from_param('ns',ns,(n3-fs)/js)

  call   to_history('n1',n1       )
  call   to_history('n2',nr       )
  call   to_history('n3',ns       )
  call   to_history('n4',1        )
  call   to_history('o1',o1       )
  call   to_history('o2',o2+fr*d2 )
  call   to_history('o3',o3+fs*d3 )
  call   to_history('o4',0.       )
  call   to_history('d1',d1       )
  call   to_history('d2',   jr*d2 )
  call   to_history('d3',   js*d3 )
  call   to_history('d4',1.       )
  
  
  if (exist_file('data')) then
    call   to_history('n1',n1       ,'data')
    call   to_history('n2',nr       ,'data')
    call   to_history('n3',ne       ,'data')
    call   to_history('n4',ns       ,'data')
    call   to_history('o1',o1       ,'data')
    call   to_history('o2',o2+fr*d2 ,'data')
    call   to_history('o3',0.       ,'data')
    call   to_history('o4',o3+fs*d3 ,'data')
    call   to_history('d1',d1       ,'data')
    call   to_history('d2',   jr*d2 ,'data')
    call   to_history('d3',1.       ,'data')
    call   to_history('d4',   js*d3 ,'data')
  end if
  
  call sep_close()
  
  allocate(datain(n1,nr,ne)); datain  = 0.
  allocate(mean  (n1,nr   )); mean    = 0.
  

  ! For each shot
  do is=1,ns
    write(0,*) 'Reading all estimates of shot:', is,'out of:',ns
    ! Read data
    ind=0;                    call sreed_window("file1" ,4,(/n1,n2,n3,ne1 /),(/n1,nr,1,ne1 /),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne1 ));ind=ind+ne1
    if (exist_file('file2' )) call sreed_window("file2" ,4,(/n1,n2,n3,ne2 /),(/n1,nr,1,ne2 /),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne2 ));ind=ind+ne2
    if (exist_file('file3' )) call sreed_window("file3" ,4,(/n1,n2,n3,ne3 /),(/n1,nr,1,ne3 /),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne3 ));ind=ind+ne3
    if (exist_file('file4' )) call sreed_window("file4" ,4,(/n1,n2,n3,ne4 /),(/n1,nr,1,ne4 /),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne4 ));ind=ind+ne4
    if (exist_file('file5' )) call sreed_window("file5" ,4,(/n1,n2,n3,ne5 /),(/n1,nr,1,ne5 /),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne5 ));ind=ind+ne5
    
    if (exist_file('file6' )) call sreed_window("file6" ,4,(/n1,n2,n3,ne6 /),(/n1,nr,1,ne6 /),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne6 ));ind=ind+ne6
    if (exist_file('file7' )) call sreed_window("file7" ,4,(/n1,n2,n3,ne7 /),(/n1,nr,1,ne7 /),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne7 ));ind=ind+ne7
    if (exist_file('file8' )) call sreed_window("file8" ,4,(/n1,n2,n3,ne8 /),(/n1,nr,1,ne8 /),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne8 ));ind=ind+ne8
    if (exist_file('file9' )) call sreed_window("file9" ,4,(/n1,n2,n3,ne9 /),(/n1,nr,1,ne9 /),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne9 ));ind=ind+ne9
    if (exist_file('file10')) call sreed_window("file10",4,(/n1,n2,n3,ne10/),(/n1,nr,1,ne10/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne10));ind=ind+ne10

    if (exist_file('file11')) call sreed_window("file11",4,(/n1,n2,n3,ne11/),(/n1,nr,1,ne11/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne11));ind=ind+ne11
    if (exist_file('file12')) call sreed_window("file12",4,(/n1,n2,n3,ne12/),(/n1,nr,1,ne12/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne12));ind=ind+ne12
    if (exist_file('file13')) call sreed_window("file13",4,(/n1,n2,n3,ne13/),(/n1,nr,1,ne13/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne13));ind=ind+ne13
    if (exist_file('file14')) call sreed_window("file14",4,(/n1,n2,n3,ne14/),(/n1,nr,1,ne14/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne14));ind=ind+ne14
    if (exist_file('file15')) call sreed_window("file15",4,(/n1,n2,n3,ne15/),(/n1,nr,1,ne15/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne15));ind=ind+ne15

    if (exist_file('file16')) call sreed_window("file16",4,(/n1,n2,n3,ne16/),(/n1,nr,1,ne16/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne16));ind=ind+ne16
    if (exist_file('file17')) call sreed_window("file17",4,(/n1,n2,n3,ne17/),(/n1,nr,1,ne17/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne17));ind=ind+ne17
    if (exist_file('file18')) call sreed_window("file18",4,(/n1,n2,n3,ne18/),(/n1,nr,1,ne18/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne18));ind=ind+ne18
    if (exist_file('file19')) call sreed_window("file19",4,(/n1,n2,n3,ne19/),(/n1,nr,1,ne19/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne19));ind=ind+ne19
    if (exist_file('file20')) call sreed_window("file20",4,(/n1,n2,n3,ne20/),(/n1,nr,1,ne20/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne20));ind=ind+ne20

    if (exist_file('file21')) call sreed_window("file21",4,(/n1,n2,n3,ne21/),(/n1,nr,1,ne21/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne21));ind=ind+ne21
    if (exist_file('file22')) call sreed_window("file22",4,(/n1,n2,n3,ne22/),(/n1,nr,1,ne22/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne22));ind=ind+ne22
    if (exist_file('file23')) call sreed_window("file23",4,(/n1,n2,n3,ne23/),(/n1,nr,1,ne23/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne23));ind=ind+ne23
    if (exist_file('file24')) call sreed_window("file24",4,(/n1,n2,n3,ne24/),(/n1,nr,1,ne24/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne24));ind=ind+ne24
    if (exist_file('file25')) call sreed_window("file25",4,(/n1,n2,n3,ne25/),(/n1,nr,1,ne25/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne25));ind=ind+ne25

    if (exist_file('file26')) call sreed_window("file26",4,(/n1,n2,n3,ne26/),(/n1,nr,1,ne26/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne26));ind=ind+ne26
    if (exist_file('file27')) call sreed_window("file27",4,(/n1,n2,n3,ne27/),(/n1,nr,1,ne27/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne27));ind=ind+ne27
    if (exist_file('file28')) call sreed_window("file28",4,(/n1,n2,n3,ne28/),(/n1,nr,1,ne28/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne28));ind=ind+ne28
    if (exist_file('file29')) call sreed_window("file29",4,(/n1,n2,n3,ne29/),(/n1,nr,1,ne29/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne29));ind=ind+ne29
    if (exist_file('file30')) call sreed_window("file30",4,(/n1,n2,n3,ne30/),(/n1,nr,1,ne30/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne30));ind=ind+ne30

    if (exist_file('file31')) call sreed_window("file31",4,(/n1,n2,n3,ne31/),(/n1,nr,1,ne31/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne31));ind=ind+ne31
    if (exist_file('file32')) call sreed_window("file32",4,(/n1,n2,n3,ne32/),(/n1,nr,1,ne32/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne32));ind=ind+ne32
    if (exist_file('file33')) call sreed_window("file33",4,(/n1,n2,n3,ne33/),(/n1,nr,1,ne33/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne33));ind=ind+ne33
    if (exist_file('file34')) call sreed_window("file34",4,(/n1,n2,n3,ne34/),(/n1,nr,1,ne34/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne34));ind=ind+ne34
    if (exist_file('file35')) call sreed_window("file35",4,(/n1,n2,n3,ne35/),(/n1,nr,1,ne35/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne35));ind=ind+ne35

    if (exist_file('file36')) call sreed_window("file36",4,(/n1,n2,n3,ne36/),(/n1,nr,1,ne36/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne36));ind=ind+ne36
    if (exist_file('file37')) call sreed_window("file37",4,(/n1,n2,n3,ne37/),(/n1,nr,1,ne37/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne37));ind=ind+ne37
    if (exist_file('file38')) call sreed_window("file38",4,(/n1,n2,n3,ne38/),(/n1,nr,1,ne38/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne38));ind=ind+ne38
    if (exist_file('file39')) call sreed_window("file39",4,(/n1,n2,n3,ne39/),(/n1,nr,1,ne39/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne39));ind=ind+ne39
    if (exist_file('file40')) call sreed_window("file40",4,(/n1,n2,n3,ne40/),(/n1,nr,1,ne40/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne40));ind=ind+ne40

    if (exist_file('file41')) call sreed_window("file41",4,(/n1,n2,n3,ne41/),(/n1,nr,1,ne41/),(/0,fr,fs+(is-1)*js,0/),(/1,jr,1,1/),4,datain(:,:,ind+1:ind+ne41));

    ! Write all data to file (all time-receiver-estimates per shot)
    if (exist_file('data')) call srite('data',datain,4*n1*nr*ne)

    do ik=1,nkill
      ! Write all data to file (all time-receiver-estimates per shot)
      datain(:,:,kill(ik))=0.
    end do
    
    ! For each receiver, calculate the mean (for each time sample)
    if (scale) then
      do ir=1,nr
        ! Calculate the mean (for each time sample)
        do it=1,n1
          mean(it,ir) = sum(datain(it,ir,:))/ne
        end do
      end do
    else
      do ir=1,nr
        do it=1,n1
          mean(it,ir) = sum(datain(it,ir,:))
        end do
      end do
    end if
    call srite('out',mean,4*n1*nr)

  end do  ! End source loop
  
  
  ! Deallocate and close
  deallocate(datain)
  deallocate(mean  )
  deallocate(kill  )
  call exit(0)
  
end program
