module filterpatch_mod
  implicit none

  contains

  recursive function quantile(k,a) result (value)
    integer, intent(in)           :: k
    real,dimension(:), intent(in) :: a
    real                          :: value
    integer                       :: j
    real                          :: ak
    ak = a(k)
    j  = count(a.lt.ak)
    if (j.ge.k) then
      value = quantile( k, pack(a,a.lt.ak))
    else
      j = count(a.gt.ak)+k-size(a)
      if (j.gt.0) then
        value = quantile( j, pack(a,a.gt.ak))
      else
        value = ak
      end if
    end if
  end function


  subroutine subsample(datain,datout,j1)
    real           :: datain(:),datout(:)
    integer        :: j1,ii,nw
    nw = size(datout)
    do ii=1,nw
      datout(ii) = datout(ii) + datain(1+(ii-1)*j1)
    end do
  end subroutine
  
  
end module
