% Include sepatlab in path
path('/homes/sep/sjoerd/lib/sepmatlab',path);

% Read SEP-format data
disp = load_data(load_history(file_in));

ff = disp.o(1)+[0:disp.n(1)-1]*disp.d(1);
pp = disp.o(2)+[0:disp.n(2)-1]*disp.d(2);
 
FS = 12;
fig=figure('visible','off');
% axes('position',[.1  .1  .8  .6])
pcolor(ff,pp,disp.data.'); shading interp;
xlabel('frequency (Hz)','FontSize',FS,'FontWeight','bold');
ylabel('slowness (ms/m)','FontSize',FS,'FontWeight','bold');
title(titel,'FontSize',FS+2,'FontWeight','bold');
set(gcf,'PaperPositionMode','auto');

set(gca,'YScale','log','YTick',[0 0.0001 0.0002 0.0003 0.0004 0.0005 0.0006 0.0007 0.0008 0.0009 0.001 0.002 0.003 0.004 0.005 0.006]);
set(gca,'YTickLabel',{'0','0.1','0.2','0.3','0.4','0.5','0.6','0.7','0.8','0.9','1','2','3','4','5','6'});
set(gca,'XScale','log','XTick',[0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1 2 3 4 4.999875]);
set(gca,'XTickLabel',{'0','0.1','0.2','0.3','0.4','0.5','0.6','0.7','0.8','0.9','1','2','3','4','5'});

%set(gca,'YScale','log','YTick',[0 0.0001 0.0002 0.0003 0.0004 0.0005 0.0006 0.0007 0.0008 0.0009 0.001 0.002 0.003 0.004 0.005 0.006]);
%set(gca,'YTickLabel',{'0','0.1','0.2','0.3','0.4','0.5','0.6','0.7','0.8','0.9','1','2','3','4','5','6'});
%set(gca,'XScale','log','XTick',[0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1 2 3 4 4.999875]);
%set(gca,'XTickLabel',{'0','0.1','0.2','0.3','0.4','0.5','0.6','0.7','0.8','0.9','1','2','3','4','5'});

axis([.15 2.0 .0005 .004]);
set(gca,'Fontsize',FS,'FontWeight','bold');

hold on;
plot([.2,.2],[.0005 .004],'Color','k');
plot([.3,.3],[.0005 .004],'Color','k');
plot([.4,.4],[.0005 .004],'Color','k');
plot([.5,.5],[.0005 .004],'Color','k');
plot([.6,.6],[.0005 .004],'Color','k');
plot([.7,.7],[.0005 .004],'Color','k');
plot([.8,.8],[.0005 .004],'Color','k');
plot([.9,.9],[.0005 .004],'Color','k');
plot([1.,1.],[.0005 .004],'Color','k');

plot([.15 2.0],[.0006 .0006],'Color','k');
plot([.15 2.0],[.0007 .0007],'Color','k');
plot([.15 2.0],[.0008 .0008],'Color','k');
plot([.15 2.0],[.0009 .0009],'Color','k');
plot([.15 2.0],[.0010 .0010],'Color','k');
plot([.15 2.0],[.0020 .0020],'Color','k');
plot([.15 2.0],[.0030 .0030],'Color','k');





fillpage(fig, 'margins', [0 0 0 0], 'papersize', [9 6]);
print(gcf, '-depsc2', file_out)
