program sdrAverage

  use sep
  use collect_mod
  use average_mod_omp
  use average_sparse_mod

  implicit none

  integer                               :: n1,n2,n3,n4,n5,n6,n7
  real                                  :: d1,d2,d3,d4,d5,d6,d7
  real                                  :: o1,o2,o3,o4,o5,o6,o7
  character*50                          :: label1,label2,label3,label4,label5,label6,label7

  real, allocatable                     :: datain(:,:,:)
  real, allocatable                     :: dataout_2d(:,:),dataout_1d(:)

  integer                               :: dir
  integer                               :: ii,jj,kk,ll,mm,nn,oo
  logical                               :: collect_l,allabs,sparse
  
  call sep_init()
  
  call from_param  ("dir",dir,2)
  call from_param ("collect",collect_l,.false.)
  call from_param ( "allabs", allabs  ,.false.)
  call from_param ( "sparse", sparse  ,.false.)

  call from_history("n1",n1,1 )
  call from_history("n2",n2,1 )
  call from_history("n3",n3,1 )
  call from_history("n4",n4,1 )
  call from_history("n5",n5,1 )
  call from_history("n6",n6,1 )
  call from_history("n7",n7,1 )

  call from_history("d1",d1,1.)
  call from_history("d2",d2,1.)
  call from_history("d3",d3,1.)
  call from_history("d4",d4,1.)
  call from_history("d5",d5,1.)
  call from_history("d6",d6,1.)
  call from_history("d7",d7,1.)

  call from_history("o1",o1,0.)
  call from_history("o2",o2,0.)
  call from_history("o3",o3,0.)
  call from_history("o4",o4,0.)
  call from_history("o5",o5,0.)
  call from_history("o6",o6,0.)
  call from_history("o7",o7,0.)

  call from_history("label1",label1," ")
  call from_history("label2",label2," ")
  call from_history("label3",label3," ")
  call from_history("label4",label4," ")
  call from_history("label5",label5," ")
  call from_history("label6",label6," ")
  call from_history("label7",label7," ")

  if (dir.eq.1 ) then;
    call to_history("n1",n2);   call to_history("n2",n3)
    call to_history("d1",d2);   call to_history("d2",d3)
    call to_history("o1",o2);   call to_history("o2",o3)
    call to_history("label1",label2);   call to_history("label2",label2)
    if (collect_l) then;
      call to_history("n3", 1 );  call to_history("n4", 1 );  call to_history("n5", 1 );  call to_history("n6", 1 );
      call to_history("d3", 1.);  call to_history("d4", 1.);  call to_history("d5", 1.);  call to_history("d6", 1.);
      call to_history("o3", 0.);  call to_history("o4", 0.);  call to_history("o5", 0.);  call to_history("o6", 0.);
      call to_history("label3", 1);  call to_history("label4", " ");  call to_history("label5", " ");  call to_history("label6", " ");
    else;
      call to_history("n3",n4);  call to_history("n4",n5);  call to_history("n5",n6);  call to_history("n6",n7);
      call to_history("d3",d4);  call to_history("d4",d5);  call to_history("d5",d6);  call to_history("d6",d7);
      call to_history("o3",o4);  call to_history("o4",o5);  call to_history("o5",o6);  call to_history("o6",o7);
      call to_history("label3",label4);  call to_history("label4",label5); call to_history("label5",label6);  call to_history("label6",label7);
    end if
    call to_history("n7",1 )
    call to_history("d7",1.)
    call to_history("o7",0.);
    call to_history("label7", " ")
  end if
  if (dir.eq.2 ) then;
    call to_history("n1",n1);   call to_history("n2",n3)
    call to_history("d1",d1);   call to_history("d2",d3)
    call to_history("o1",o1);   call to_history("o2",o3)
    call to_history("label1",label1);   call to_history("label2",label3)
    if (collect_l) then;
      call to_history("n3", 1);  call to_history("n4", 1);  call to_history("n5", 1 );  call to_history("n6", 1 );
      call to_history("d3", 1);  call to_history("d4", 1);  call to_history("d5", 1.);  call to_history("d6", 1.);
      call to_history("o3", 1);  call to_history("o4", 1);  call to_history("o5", 0.);  call to_history("o6", 0.);
      call to_history("label3", 1);  call to_history("label4", " ");  call to_history("label5", " ");  call to_history("label6", " ");
    else;
      call to_history("n3",n4);  call to_history("n4",n5);  call to_history("n5",n6);  call to_history("n6",n7);
      call to_history("d3",d4);  call to_history("d4",d5);  call to_history("d5",d6);  call to_history("d6",d7);
      call to_history("o3",o4);  call to_history("o4",o5);
      call to_history("label3",label4);  call to_history("label4",label5); call to_history("label5",label6);  call to_history("label6",label7);
    end if
    call to_history("n7",1 )
    call to_history("d7",1.)
    call to_history("o7",0.);
    call to_history("label7", " ")
  end if
  if (dir.eq.3 ) then;
    call to_history("n1",n1);   call to_history("n2",n2);
    call to_history("d1",d1);   call to_history("d2",d2);
    call to_history("o1",o1);   call to_history("o2",o2);
    call to_history("label1",label1);   call to_history("label2",label2);
    if (collect_l) then;
      call to_history("n3", 1);  call to_history("n4", 1);  call to_history("n5", 1 );  call to_history("n6", 1 );
      call to_history("d3", 1);  call to_history("d4", 1);  call to_history("d5", 1.);  call to_history("d6", 1.);
      call to_history("o3", 1);  call to_history("o4", 1);  call to_history("o5", 0.);  call to_history("o6", 0.);
      call to_history("label3", 1);  call to_history("label4", " ");  call to_history("label5", " ");  call to_history("label6", " ");
    else;
      call to_history("n3",n4);  call to_history("n4",n5);  call to_history("n5",n6);  call to_history("n6",n7);
      call to_history("d3",d4);  call to_history("d4",d5);  call to_history("d5",d6);  call to_history("d6",d7);
      call to_history("o3",o4);  call to_history("o4",o5);  call to_history("o5",o6);  call to_history("o6",o7);
      call to_history("label3",label4);  call to_history("label4",label5); call to_history("label5",label6);  call to_history("label6",label7);
    end if
    call to_history("n7",1 )
    call to_history("d7",1.)
    call to_history("o7",0.);
    call to_history("label7", " ")
  end if
  if (dir.eq.23) then;
    call to_history("n1",n1);
    call to_history("d1",d1);
    call to_history("o1",o1);
    call to_history("label1",label1);
    if (collect_l) then;
      call to_history("n2", 1);  call to_history("n3", 1);  call to_history("n4",1 );  call to_history("n5", 1 );  
      call to_history("d2", 1);  call to_history("d3", 1);  call to_history("d4",1.);  call to_history("d5", 1.);  
      call to_history("o2", 1);  call to_history("o3", 1);  call to_history("o4",0.);  call to_history("o5", 0.);  
      call to_history("label2", 1);  call to_history("label3", " ");  call to_history("label4", " ");  call to_history("label5", " ");
    else;
      call to_history("n2",n4);  call to_history("n3",n5);  call to_history("n4",n6);  call to_history("n5",n7);  
      call to_history("d2",d4);  call to_history("d3",d5);  call to_history("d4",d6);  call to_history("d5",d7);  
      call to_history("o2",o4);  call to_history("o3",o5);  call to_history("o4",o6);  call to_history("o5",o7);  
      call to_history("label2",label4);  call to_history("label3",label5);  call to_history("label4", " ");  call to_history("label5", " ");
    end if
    call to_history("n6",1 )
    call to_history("d6",1.)
    call to_history("o6",0.);
    call to_history("label6", " ")
    call to_history("n7",1 )
    call to_history("d7",1.)
    call to_history("o7",0.);
    call to_history("label7", " ")
  end if
  if (dir.eq.13) then;
    call to_history("n1",n2);
    call to_history("d1",d2);
    call to_history("o1",o2);
    call to_history("label1",label2);
    if (collect_l) then;
      call to_history("n2", 1);  call to_history("n3", 1);  call to_history("n4",1 );  call to_history("n5", 1 );  
      call to_history("d2", 1);  call to_history("d3", 1);  call to_history("d4",1.);  call to_history("d5", 1.);  
      call to_history("o2", 1);  call to_history("o3", 1);  call to_history("o4",0.);  call to_history("o5", 0.); 
      call to_history("label2", 1);  call to_history("label3", " ");  call to_history("label4", " ");  call to_history("label5", " ");
    else;
      call to_history("n2",n4);  call to_history("n3",n5);  call to_history("n4",1 );  call to_history("n5", 1 );  
      call to_history("d2",d4);  call to_history("d3",d5);  call to_history("d4",1.);  call to_history("d5", 1.); 
      call to_history("o2",o4);  call to_history("o3",o5);  call to_history("o4",0.);  call to_history("o5", 0.); 
      call to_history("label2",label4);  call to_history("label3",label5);  call to_history("label4", " ");  call to_history("label5", " ");
    end if
    call to_history("n6",1 )
    call to_history("d6",1.)
    call to_history("o6",0.);
    call to_history("label6", " ")
    call to_history("n7",1 )
    call to_history("d7",1.)
    call to_history("o7",0.);
    call to_history("label7", " ")
  end if
  if (dir.eq.12) then;
    call to_history("n1",n3);
    call to_history("d1",d3);
    call to_history("o1",o3);
    call to_history("label1",label3);
    if (collect_l) then;
      call to_history("n2", 1);  call to_history("n3", 1);  call to_history("n4",1 );  call to_history("n5", 1 );  
      call to_history("d2", 1);  call to_history("d3", 1);  call to_history("d4",1.);  call to_history("d5", 1.);  
      call to_history("o2", 1);  call to_history("o3", 1);  call to_history("o4",0.);  call to_history("o5", 0.); 
      call to_history("label2", 1);  call to_history("label3", " ");  call to_history("label4", " ");  call to_history("label5", " ");
    else;
      call to_history("n2",n4);  call to_history("n3",n5);  call to_history("n4",1 );  call to_history("n5", 1 );  
      call to_history("d2",d4);  call to_history("d3",d5);  call to_history("d4",1.);  call to_history("d5", 1.); 
      call to_history("o2",o4);  call to_history("o3",o5);  call to_history("o4",0.);  call to_history("o5", 0.); 
      call to_history("label2",label4);  call to_history("label3",label5);  call to_history("label4", " ");  call to_history("label5", " ");
    end if
    call to_history("n6",1 )
    call to_history("d6",1.)
    call to_history("o6",0.);
    call to_history("label6", " ")
    call to_history("n7",1 )
    call to_history("d7",1.)
    call to_history("o7",0.);
    call to_history("label7", " ")
  end if

  
  call sep_close()
  
  
  ! Allocations
  if (dir.eq.1 ) then;  allocate(datain(n1,n2,n3),dataout_2d(n2,n3)); end if
  if (dir.eq.2 ) then;  allocate(datain(n1,n2,n3),dataout_2d(n1,n3)); end if
  if (dir.eq.3 ) then;  allocate(datain(n1,n2,n3),dataout_2d(n1,n2)); end if
  if (dir.eq.23) then;  allocate(datain(n1,n2,n3),dataout_1d(n1   )); end if
  if (dir.eq.13) then;  allocate(datain(n1,n2,n3),dataout_1d(n2   )); end if
  if (dir.eq.12) then;  allocate(datain(n1,n2,n3),dataout_1d(n3   )); end if
  
  if (collect_l) then
    if (dir.eq.1 ) then;  call collect_init(n2,n3);  end if
    if (dir.eq.2 ) then;  call collect_init(n1,n3);  end if
    if (dir.eq.3 ) then;  call collect_init(n1,n2);  end if
    if (dir.eq.23) then;  call collect_init(n1   );  end if
    if (dir.eq.13) then;  call collect_init(n2   );  end if
    if (dir.eq.12) then;  call collect_init(n3   );  end if
  end if


  ! Average
  if (sparse) then

  do oo=1,n7; do nn=1,n6; do mm=1,n5; do ll=1,n4
    !write(0,*) ll

    datain=0.
    if (allocated(dataout_1d)) then; dataout_1d=0.;  end if
    if (allocated(dataout_2d)) then; dataout_2d=0.;  end if

    ! Read in data
    do kk=1,n3
      call sreed("in", datain(:,:,kk),4*n1*n2)
    end do

    if (allabs) then; datain = abs(datain); end if

    if (dir.eq.1 ) then;  call  average_sparse_1_op(datain,dataout_2d);
      if (collect_l) then;  call collect(dataout_2d);  else;  call srite("out",dataout_2d,4*size(dataout_2d));  end if
    end if
    if (dir.eq.2 ) then;  call  average_sparse_2_op(datain,dataout_2d);
      if (collect_l) then;  call collect(dataout_2d);  else;  call srite("out",dataout_2d,4*size(dataout_2d));  end if
    end if
    if (dir.eq.3 ) then;  call  average_sparse_3_op(datain,dataout_2d);
      if (collect_l) then;  call collect(dataout_2d);  else;  call srite("out",dataout_2d,4*size(dataout_2d));  end if
    end if
    if (dir.eq.23) then;  call average_sparse_23_op(datain,dataout_1d);
      if (collect_l) then;  call collect(dataout_1d);  else;  call srite("out",dataout_1d,4*size(dataout_1d));  end if
    end if
    if (dir.eq.13) then;  call average_sparse_13_op(datain,dataout_1d);
      if (collect_l) then;  call collect(dataout_1d);  else;  call srite("out",dataout_1d,4*size(dataout_1d));  end if
    end if
    if (dir.eq.12) then;  call average_sparse_12_op(datain,dataout_1d);
      if (collect_l) then;  call collect(dataout_1d);  else;  call srite("out",dataout_1d,4*size(dataout_1d));  end if
    end if

  end do;     end do;      end do;     end do
  
  if (collect_l) then;  
    if (dir.eq.1 .or. dir.eq.2 .or. dir.eq.3 ) then;
      call get_collected_average(dataout_2d,n4*n5);  call srite( "out", dataout_2d, 4*size(dataout_2d));
    end if
    if (dir.eq.23.or. dir.eq.13.or. dir.eq.12) then;
      call get_collected_average(dataout_1d,n4*n5);  call srite( "out", dataout_1d, 4*size(dataout_1d));    
    end if
  end if

  else

  do oo=1,n7; do nn=1,n6; do mm=1,n5; do ll=1,n4
    !write(0,*) ll

    datain=0.
    if (allocated(dataout_1d)) then; dataout_1d=0.;  end if
    if (allocated(dataout_2d)) then; dataout_2d=0.;  end if

    ! Read in data
    do kk=1,n3
      call sreed("in", datain(:,:,kk),4*n1*n2)
    end do

    if (allabs) then; datain = abs(datain); end if

    if (dir.eq.1 ) then;  call  average_1_op(datain,dataout_2d);
      if (collect_l) then;  call collect(dataout_2d);  else;  call srite("out",dataout_2d,4*size(dataout_2d));  end if
    end if
    if (dir.eq.2 ) then;  call  average_2_op(datain,dataout_2d);
      if (collect_l) then;  call collect(dataout_2d);  else;  call srite("out",dataout_2d,4*size(dataout_2d));  end if
    end if
    if (dir.eq.3 ) then;  call  average_3_op(datain,dataout_2d);
      if (collect_l) then;  call collect(dataout_2d);  else;  call srite("out",dataout_2d,4*size(dataout_2d));  end if
    end if
    if (dir.eq.23) then;  call average_23_op(datain,dataout_1d);
      if (collect_l) then;  call collect(dataout_1d);  else;  call srite("out",dataout_1d,4*size(dataout_1d));  end if
    end if
    if (dir.eq.13) then;  call average_13_op(datain,dataout_1d);
      if (collect_l) then;  call collect(dataout_1d);  else;  call srite("out",dataout_1d,4*size(dataout_1d));  end if
    end if
    if (dir.eq.12) then;  call average_12_op(datain,dataout_1d);
      if (collect_l) then;  call collect(dataout_1d);  else;  call srite("out",dataout_1d,4*size(dataout_1d));  end if
    end if

  end do;     end do;      end do;     end do
  
  if (collect_l) then;  
    if (dir.eq.1 .or. dir.eq.2 .or. dir.eq.3 ) then;
      call get_collected_average(dataout_2d,n4*n5);  call srite( "out", dataout_2d, 4*size(dataout_2d));
    end if
    if (dir.eq.23.or. dir.eq.13.or. dir.eq.12) then;
      call get_collected_average(dataout_1d,n4*n5);  call srite( "out", dataout_1d, 4*size(dataout_1d));    
    end if
  end if


  end if


  ! Deallocate
  deallocate(datain)
  if (allocated(dataout_1d)) then; deallocate(dataout_1d);  end if
  if (allocated(dataout_2d)) then; deallocate(dataout_2d);  end if
  if (      collect_l      ) then; call collect_close();    end if

  call exit(0)
  
end program
