program sdrFFT1d
! Tape a datafile

  use sep                      ! Main SEP module
  use fftw_mod
  implicit none
  
  real, allocatable               :: data_in (:,:,:)
  complex,allocatable             :: data_out(:,:,:)
  integer                         :: n(3),nw,nk1,nk2
  real                            :: d(3),o(3),dw,dk1,dk2
  integer                         :: dir
  logical                         :: adj
  integer                         :: ii,jj,kk,ll,mm
  integer                         :: n4,n5
  integer                         :: loop,unit
  real, parameter                 :: pi=3.14159265
  
  ! Open I/O headerfiles
  call sep_init()              ! Call to SEP module 
  
  ! Read input parameters for taper, there is lots of options :-)
  call from_param ("dir" ,dir,   1    )
  call from_param ("adj" ,adj,.false. )
  call from_param ("loop",loop,0)
  call from_param ("unit",unit,1)
  
  if (dir.eq.1) then
    call from_history("n2", n(2) ,1)
    call from_history("n3", n(3) ,1)
    call from_history("d2", d(2) ,1.)
    call from_history("d3", d(3) ,1.)
    call from_history("o2", o(2) ,0.)
    call from_history("o3", o(3) ,0.)
    if (adj) then;
      call from_history("n1", nw , 1)
      call from_history("d1", dw , 1.)
      call fft_r2c_units_t(adj,nt=n(1),dt=d(1),nw=nw,df=dw)
      call to_history("n1",    n(1) )
      call to_history("d1",    d(1) )
      call to_history("o1",    0.   )
      call to_history("esize", 4    )
    else;
      call from_history("n1", n(1) ,1)
      call from_history("d1", d(1) ,1.)
      call fft_r2c_units_t(adj,nt=n(1),dt=d(1),nf=nw,df=dw)
      if (unit.eq.2) then; dw = 2.*pi*dw; end if
      call to_history("n1",    nw  )
      call to_history("d1",    dw  )
      call to_history("o1",    0.  )
      call to_history("esize", 8   )
    end if
  end if
  
  if (dir.eq.2) then
    call from_history("n1", n(1) ,1)
    call from_history("n3", n(3) ,1)
    call from_history("d1", d(1) ,1.)
    call from_history("d3", d(3) ,1.)
    call from_history("o1", o(1) ,0.)
    call from_history("o3", o(3) ,0.)
    if (adj) then;
      call from_history("n2", nk1 ,1)
      call from_history("d2", dk1 ,1.)
      call fft_r2c_units_x(adj,nx=n(2),dx=d(2),nrk=nk1,dk=dk1)
      call to_history("n2",    n(2) )
      call to_history("d2",    d(2) )
      call to_history("o2",    0.   )
      call to_history("esize", 4    )
    else;
      call from_history("n2", n(2) ,1)
      call from_history("d2", d(2) ,1.)
      call from_history("o2", o(2) ,0.)
      call fft_r2c_units_x(adj,nx=n(2),dx=d(2),nrk=nk1,dk=dk1)
      if (unit.eq.2) then; dk1 = 2.*pi*dk1; end if
      call to_history("n2",    nk1 )
      call to_history("d2",    dk1 )
      call to_history("o2",    0.  )
      call to_history("esize", 8   )
    end if
  end if
  
  if (dir.eq.3) then
    call from_history("n1", n(1) ,1)
    call from_history("n2", n(2) ,1)
    call from_history("d1", d(1) ,1.)
    call from_history("d2", d(2) ,1.)
    call from_history("o1", o(1) ,0.)
    call from_history("o2", o(2) ,0.)
    if (adj) then;
      call from_history("n2", nk2  ,1)
      call from_history("d2", dk2  ,1.)
      call fft_r2c_units_x(adj,nx=n(3),dx=d(3),nrk=nk2,drk=dk2)
      call to_history("n2",    n(3) )
      call to_history("d2",    d(3) )
      call to_history("o2",    0.   )
      call to_history("esize", 4    )
    else;
      call from_history("n2", n(3) ,1)
      call from_history("d2", d(3) ,1.)
      call fft_r2c_units_x(adj,nx=n(3),dx=d(3),nrk=nk2,dk=dk1)
      if (unit.eq.2) then; dk2 = 2.*pi*dk2; end if
      call to_history("n2",    nk2 )
      call to_history("d2",    dk2 )
      call to_history("o2",    0.  )
      call to_history("esize", 8   )
    end if
  end if
  
  call from_history("n4",n4,1)
  call from_history("n5",n5,1)

  ! Close properly
  call sep_close ()            ! Close all I/O to headerfiles

  if (loop.eq.0) then

  ! Allocate the arrays datain & dataout, and Initalize the Module
  if (dir.eq.1) then
    allocate ( data_in(n(1),n(2),n(3)),data_out(nw ,n(2),n(3)) )
    ! Initialize the FFTW functions
    call fftw1d_1_r2c_lop_init(nt_in=n(1))
  end if
  if (dir.eq.2) then
    allocate ( data_in(n(1),n(2),n(3)),data_out(n(1),nk1,n(3)) )
    ! Initialize the FFTW functions
    call fftw1d_2_r2c_lop_init(nt_in=n(2))
  end if
  if (dir.eq.3) then
    allocate ( data_in(n(1),n(2),n(3)),data_out(n(1),n(2),nk2) )
    ! Initialize the FFTW functions
    call fftw1d_3_r2c_lop_init(nt_in=n(3))
  end if
  
  do mm=1,n5
  do ll=1,n4

  ! Read in data from input file
  if (adj) then;
    call sep_read  (data_out)
  else;
    call sep_read  (data_in )
  end if
  
  ! Execute Taper
  call fftw1d_1_r2c_lop(adj,.false.,data_in,data_out)
  
  ! Write data to output file
  if (adj) then;
    call sep_write (data_in )
  else;
    call sep_write (data_out)
  end if

  end do
  end do
  
  else if (loop.eq.3) then


  ! Allocate the arrays datain & dataout, and Initalize the Module
  if (dir.eq.1) then
    allocate ( data_in(n(1),n(2),1),data_out(nw ,n(2),1) )
    ! Initialize the FFTW functions
    call fftw1d_1_r2c_lop_init(nt_in=n(1))
  end if
  if (dir.eq.2) then
    allocate ( data_in(n(1),n(2),1),data_out(n(1),nk1,1) )
    ! Initialize the FFTW functions
    call fftw1d_2_r2c_lop_init(nt_in=n(2))
  end if
  
  do mm=1,n5
  do ll=1,n4
  do kk=1,n(3)

  ! Read in data from input file
  if (adj) then;
    call sep_read  (data_out)
  else;
    call sep_read  (data_in )
  end if
  
  ! Execute Taper
  call fftw1d_1_r2c_lop(adj,.false.,data_in,data_out)
  
  ! Write data to output file
  if (adj) then;
    call sep_write (data_in )
  else;
    call sep_write (data_out)
  end if

  end do
  end do
  end do



  else if (loop.eq.23) then



  ! Allocate the arrays datain & dataout, and Initalize the Module
  if (dir.eq.1) then
    allocate ( data_in(n(1),1,1),data_out(nw ,1,1) )
    ! Initialize the FFTW functions
    call fftw1d_1_r2c_lop_init(nt_in=n(1))
  end if

  
  do mm=1,n5
  do ll=1,n4
  do kk=1,n(3)
  do jj=1,n(2)

  ! Read in data from input file
  if (adj) then;
    call sep_read  (data_out)
  else;
    call sep_read  (data_in )
  end if
  
  ! Execute Taper
  call fftw1d_1_r2c_lop(adj,.false.,data_in,data_out)
  
  ! Write data to output file
  if (adj) then;
    call sep_write (data_in )
  else;
    call sep_write (data_out)
  end if

  end do
  end do
  end do
  end do



  end if

  ! Deallocate memory
  deallocate     (data_in,data_out)
  if (dir.eq.1) then
    call fftw1d_1_r2c_lop_close()
  end if
  if (dir.eq.2) then
    call fftw1d_2_r2c_lop_close()
  end if
  if (dir.eq.3) then
    call fftw1d_3_r2c_lop_close()
  end if  

  ! Force clean exit
  call exit (0)
  
end program

