! Calculate Single Taper Spectrum in 1d (F domain input)
program sdrSpectra_w
  ! types:
  ! 1 - amplitude
  ! 2 - power (ampl**2)

  use sep
  use spectra_mod

  implicit none

  complex,allocatable         :: data_in (:,:,:)
  real,allocatable            :: data_out(:,:,:)
  integer                     :: n1,n2,n3,n4,n5
  real                        :: d1,d2,d3,o1,o2,o3
  integer                     :: ll,mm
  integer                     :: type

  call sep_init()

  call from_history("n1",n1,1)
  call from_history("n2",n2,1)
  call from_history("n3",n3,1)
  call from_history("n4",n4,1)
  call from_history("n5",n5,1)

  call to_history  ("esize",4)

  call from_param("type",type,1)

  call sep_close()

  allocate( data_in(n1,n2,n3) , data_out(n1,n2,n3) )


  if (type.eq.1) then

    do mm=1,n5; do ll=1,n4
    ! Read Data
    call sreed("in" ,data_in ,8*size(data_in ))
    ! Compute Spectrum
    call spectra_ampl(data_in,data_out)
    ! Write Data
    call srite("out",data_out,4*size(data_out))
    end do;     end do
    
  else

    do mm=1,n5; do ll=1,n4
    ! Read Data
    call sreed("in" ,data_in ,8*size(data_in ))
    ! Compute Spectrum
    call spectra_powr(data_in,data_out)
    ! Write Data
    call srite("out",data_out,4*size(data_out))
    end do;     end do
    
  end if

  deallocate( data_in , data_out )

end program
