
  subroutine fftshift1d_real_real_1_1d(adj,add,m,d)
    logical, intent(in)      :: adj,add
    real                     ::         m(:),d(:)
    integer                  :: n1
    
    call                adjnull(adj,add,m,d)
    n1 = size(m,1)
    if ( adj ) then
      m(     1:n1/2) = m(     1:n1/2) + d(n1/2+1:n1  )
      m(n1/2+1:n1  ) = m(n1/2+1:n1  ) + d(     1:n1/2)
    else
      d(     1:n1/2) = d(     1:n1/2) + m(n1/2+1:n1  )
      d(n1/2+1:n1  ) = d(n1/2+1:n1  ) + m(     1:n1/2)
    end if
    
  end subroutine
  
  
  
  subroutine fftshift1d_real_real_1_2d(adj,add,m,d)
    logical, intent(in)      :: adj,add
    real                     :: m(:,:),d(:,:)
    integer                  :: n1

    call                adjnull(adj,add,m,d)
    n1 = size(m,1)
    if ( adj ) then
      m(      1:n1/2 ,:) = m(      1:n1/2 ,:) + d( n1/2+1:n1  ,: )
      m( n1/2+1:n1   ,:) = m( n1/2+1:n1   ,:) + d(      1:n1/2,: )
    else
      d(      1:n1/2 ,:) = d(      1:n1/2 ,:) + m( n1/2+1:n1  ,: )
      d( n1/2+1:n1   ,:) = d( n1/2+1:n1   ,:) + m(      1:n1/2,: )
    end if
    
  end subroutine



  subroutine fftshift1d_real_real_1_3d(adj,add,m,d)
    logical, intent(in)      :: adj,add
    real                     :: m(:,:,:),d(:,:,:)
    integer                  :: n1

    call                adjnull(adj,add,m,d)
    n1 = size(m,1)
    if ( adj ) then
      m(      1:n1/2 ,:,:) = m(      1:n1/2 ,:,:) + d( n1/2+1:n1  ,:,:)
      m( n1/2+1:n1   ,:,:) = m( n1/2+1:n1   ,:,:) + d(      1:n1/2,:,:)
    else
      d(      1:n1/2 ,:,:) = d(      1:n1/2 ,:,:) + m( n1/2+1:n1  ,:,:)
      d( n1/2+1:n1   ,:,:) = d( n1/2+1:n1   ,:,:) + m(      1:n1/2,:,:)
    end if
    
  end subroutine




  subroutine fftshift1d_real_real_2_2d(adj,add,m,d)
    logical, intent(in)      :: adj,add
    real                     :: m(:,:),d(:,:)
    integer                  :: n2

    call                adjnull(adj,add,m,d)
    n2 = size(m,2)
    if ( adj ) then
      m(:,      1:n2/2 ) = m(:,      1:n2/2 ) + d(:, n2/2+1:n2   )
      m(:, n2/2+1:n2   ) = m(:, n2/2+1:n2   ) + d(:,      1:n2/2 )
    else
      d(:,      1:n2/2 ) = d(:,      1:n2/2 ) + m(:, n2/2+1:n2   )
      d(:, n2/2+1:n2   ) = d(:, n2/2+1:n2   ) + m(:,      1:n2/2 )
    end if
    
  end subroutine


  subroutine fftshift1d_real_real_2_3d(adj,add,m,d)
    logical, intent(in)      :: adj,add
    real                     :: m(:,:,:),d(:,:,:)
    integer                  :: n2

    call                adjnull(adj,add,m,d)
    n2 = size(m,2)
    if ( adj ) then
      m(:,      1:n2/2 ,:) = m(:,      1:n2/2 ,:) + d(:, n2/2+1:n2   ,:)
      m(:, n2/2+1:n2   ,:) = m(:, n2/2+1:n2   ,:) + d(:,      1:n2/2 ,:)
    else
      d(:,      1:n2/2 ,:) = d(:,      1:n2/2 ,:) + m(:, n2/2+1:n2   ,:)
      d(:, n2/2+1:n2   ,:) = d(:, n2/2+1:n2   ,:) + m(:,      1:n2/2 ,:)
    end if
    
  end subroutine



  subroutine fftshift1d_real_real_3_3d(adj,add,m,d)
    logical, intent(in)      :: adj,add
    real                     :: m(:,:,:),d(:,:,:)
    integer                  :: n3

    call                adjnull(adj,add,m,d)
    n3 = size(m,3)
    if ( adj ) then
      m(:,:,      1:n3/2 ) = m(:,:,      1:n3/2 ) + d(:,:, n3/2+1:n3   )
      m(:,:, n3/2+1:n3   ) = m(:,:, n3/2+1:n3   ) + d(:,:,      1:n3/2 )
    else
      d(:,:,      1:n3/2 ) = d(:,:,      1:n3/2 ) + m(:,:, n3/2+1:n3   )
      d(:,:, n3/2+1:n3   ) = d(:,:, n3/2+1:n3   ) + m(:,:,      1:n3/2 )
    end if
    
  end subroutine


