module fftshift_io_mod
  
  use sep
  
  interface fftshift_sreed
    module procedure fftshift1d_sreed_1d
!    module procedure fftshift2d_sreed_2d
!    module procedure fftshift3d_sreed_3d
  end interface

  interface fftshift_srite
    module procedure fftshift1d_srite_1d
 !   module procedure fftshift2d_srite_2d
 !   module procedure fftshift3d_srite_3d
  end interface

  interface fftshift1d_sreed
    module procedure fftshift1d_sreed_1d
    module procedure fftshift1d_sreed_2d
    module procedure fftshift1d_sreed_3d
  end interface

  interface fftshift1d_srite
    module procedure fftshift1d_srite_1d
    module procedure fftshift1d_srite_2d
    module procedure fftshift1d_srite_3d
  end interface

!  interface fftshift2dsreed
!    module procedure fftshift2dsreed_2d
!    module procedure fftshift2dsreed_3d
!  end interface

!  interface fftshift2dsrite
!    module procedure fftshift2dsrite_2d
!    module procedure fftshift2dsrite_3d
!  end interface

!  interface fftshift3dsreed
!    module procedure fftshift3dsreed_3d
!  end interface

!  interface fftshift3dsrite
!    module procedure fftshift3dsrite_3d
!  end interface

  contains


  subroutine fftshift1d_sreed_1d(tag,array,n1,esize)
    integer             ::                n1,esize
    real                ::          array(:)
    character (len=*)   ::      tag
    integer             ::                nt
    integer             ::                  a,b,c,d
    integer             ::                sizee
    
    nt    = size(array,1)

    a     = 1
    b     =   n1/2
    c     = 1-n1/2+nt
    d     =        nt

    sizee = esize*n1/2

    call sreed( tag, array(c:d), sizee );
    call sreed( tag, array(a:b), sizee );
    
  end subroutine
  
  subroutine fftshift1d_sreed_2d(tag,array,n1,n2,esize)
    integer             ::                n1,n2,esize
    real                ::          array(:,:)
    character (len=*)   ::      tag
    integer             ::                nt,nx
    integer             ::                  a,b,c,d
    integer             ::                jj,   sizee
    
    nt    = size(array,1)
    nx    = size(array,2)

    a     = 1
    b     =   n1/2
    c     = 1-n1/2+nt
    d     =        nt

    sizee = esize*n1/2

    do jj=1,nx
      call sreed( tag, array(c:d,jj), sizee );
      call sreed( tag, array(a:b,jj), sizee );
    end do
    
  end subroutine

  subroutine fftshift1d_sreed_3d(tag,array,n1,n2,n3,esize)
    integer             ::                n1,n2,n3,esize
    real                ::          array(:,:,:)
    character (len=*)   ::      tag
    integer             ::                nt,nx,ny
    integer             ::                  a,b,c,d
    integer             ::                jj,kk,sizee
    
    nt    = size(array,1)
    nx    = size(array,2)
    ny    = size(array,3)

    a     = 1
    b     =   n1/2
    c     = 1-n1/2+nt
    d     =        nt

    sizee = esize*n1/2

    do kk=1,ny
    do jj=1,nx
      call sreed( tag, array(c:d,jj,kk), sizee );
      call sreed( tag, array(a:b,jj,kk), sizee );
    end do
    end do
    
  end subroutine
  




  subroutine fftshift1d_srite_1d(tag,array,n1,esize)
    integer             ::                n1,esize
    real                ::          array(:)
    character (len=*)   ::      tag
    integer             ::                nt
    integer             ::                  a,b,c,d
    integer             ::                sizee
    
    nt    = size(array,1)

    a     = 1
    b     =   n1/2
    c     = 1-n1/2+nt
    d     =        nt

    sizee = esize*n1/2

    call srite( tag, array(c:d), sizee );
    call srite( tag, array(a:b), sizee );
    
  end subroutine
  
  subroutine fftshift1d_srite_2d(tag,array,n1,n2,esize)
    integer             ::                n1,n2,esize
    real                ::          array(:,:)
    character (len=*)   ::      tag
    integer             ::                nt,nx
    integer             ::                  a,b,c,d
    integer             ::                jj,   sizee
    
    nt    = size(array,1)
    nx    = size(array,2)

    a     = 1
    b     =   n1/2
    c     = 1-n1/2+nt
    d     =        nt

    sizee = esize*n1/2

    do jj=1,nx
      call srite( tag, array(c:d,jj), sizee );
      call srite( tag, array(a:b,jj), sizee );
    end do
    
  end subroutine

  subroutine fftshift1d_srite_3d(tag,array,n1,n2,n3,esize)
    integer             ::                n1,n2,n3,esize
    real                ::          array(:,:,:)
    character (len=*)   ::      tag
    integer             ::                nt,nx,ny
    integer             ::                  a,b,c,d
    integer             ::                jj,kk,sizee
    
    nt    = size(array,1)
    nx    = size(array,2)
    ny    = size(array,3)

    a     = 1
    b     =   n1/2
    c     = 1-n1/2+nt
    d     =        nt

    sizee = esize*n1/2

    do kk=1,ny
    do jj=1,nx
      call srite( tag, array(c:d,jj,kk), sizee );
      call srite( tag, array(a:b,jj,kk), sizee );
    end do
    end do
    
  end subroutine


end module
