module get_slepian_mod
 

  use slepian_mod
  implicit none

  real(8), allocatable, private  :: lambda(:),theta(:),mtaper8(:,:),mtaper8_com(:,:)
  integer, private               :: n1,nt


  ! (Re)Initialize this module
  subroutine mtapers_init(n1_in,nt_in)
    integer, intent(in),optional  :: n1_in,nt_in

    if (present(n1_in )) then;  n1 = n1_in;  else;  n1 = 1024;  end if;
    if (present(nt_in )) then;  nt = nt_in;  else;  nt = 4   ;  end if;
    
    if (.not. allocated(mtaper8)) then; allocate( mtaper8(n1,nt) ); call addnull(.false.,mtaper8); end if;

  end subroutine

  ! Close this module
  subroutine mtapers_close()
    if (allocated(mtaper8)) then; deallocate( mtaper8 ); end if;
    if (allocated(lambda )) then; deallocate( lambda  ); end if; 
    if (allocated(theta  )) then; deallocate(  theta  ); end if;
  end subroutine

  subroutine slepian        (n_in,tbp_in,scale_in)
    integer, intent(in), optional :: n_in
    real   , intent(in), optional ::      tbp_in,scale_in
    integer                       :: n
    real                          :: tbp,scale
    logical                       :: inv,add
    
    if (present(    n_in)) then;     n = n_in;     else;    n  = n1;   end if;
    if (present(  tbp_in)) then;   tbp = tbp_in;   else;   tbp = 4.;  end if;
    if (present(scale_in)) then; scale = scale_in; else; scale = 1. ; end if;

    call addnull(.false.,mtaper8_com)
    ! Calculating tapers
    if (n<20000) then
      ! write(0,*) "This one",n,tbp,nt
       call dpss(             n,dble(tbp),nt,mtaper8_com,lambda,theta)
    else
       !  write(0,*) 'Computing DPSS with interpolation'
       call dpss_spline(10000,n,dble(tbp),nt,mtaper8_com,lambda,theta)
    end if
    !write(0,*) mtaper8_com

    mtaper8_com = mtaper8_com*scale

   ! write(0,*)  
   ! write(0,*) "Compare the Taoers"
   ! write(0,*) "nt,tbp,n1:" ,nt,tbp,n
   ! write(0,*) "vn4:", real(mtaper8_com)

  end subroutine

end module
