module killer_mod

  implicit none

  integer,private             :: ind_1(100)
  integer,private             :: ind_2(100)
  integer,private             :: ind_3(100)
  integer,private             :: NKILL

  contains

  interface killer_op
    module procedure killer_op1d
    module procedure killer_op2d
    module procedure killer_op3d
  end interface
  

  subroutine killer_init          (n,ind1,ind2,ind3)
    integer,intent(in)          :: n
    integer,intent(in),optional ::         ind1(n),ind2(n),ind2(n)
    integer                     :: ii
    ind_2 = 0
    ind_3 = 0
    NKILL = n
    if (present(ind1)) then;
      do ii=1,NKILL;  ind_1(ii)=ind1(ii);  end do
    end if
    if (present(ind2)) then;
      do ii=1,NKILL;  ind_2(ii)=ind2(ii);  end do
    end if
    if (present(ind3)) then;
      do ii=1,NKILL;  ind_3(ii)=ind3(ii);  end do
    end if
  end subroutine


  subroutine killer_op1d (array)
    real,intent(inout) :: array(:)
    integer            :: ii

    do ii=1,NKILL
      array(ind_1(ii)) = 0.
    end do
    
  end subroutine


  subroutine killer_op2d (array)
    real,intent(inout) :: array(:,:)
    integer            :: ii

    if      (sum(ind_1).ne.0..and.sum(ind_2).eq.0.) then
      do ii=1,NKILL
        array(ind_1(ii),:) = 0.
      end do
    else if (sum(ind_1).eq.0..and.sum(ind_2).ne.0.) then
      do ii=1,NKILL
        array(:,ind_2(ii)) = 0.
      end do
    else
      do ii=1,NKILL
        array(ind_1(ii),ind_2(ii)) = 0.
      end do
    end if
    
  end subroutine




  subroutine killer_op3d (array)
    real,intent(inout) :: array(:,:,:)
    integer            :: ii

    if      (sum(ind_1).ne.0..and.sum(ind_2).eq.0..and.sum(ind_3).eq.0.) then
      do ii=1,NKILL
        array(ind_1(ii),:,:) = 0.
      end do
    else if (sum(ind_1).eq.0..and.sum(ind_2).ne.0..and.sum(ind_3).eq.0.) then
      do ii=1,NKILL
        array(:,ind_2(ii),:) = 0.
      end do
    else if (sum(ind_1).eq.0..and.sum(ind_2).eq.0..and.sum(ind_3).ne.0.) then
      do ii=1,NKILL
        array(:,:,ind_3(ii)) = 0.
      end do
    else if (sum(ind_1).ne.0..and.sum(ind_2).ne.0..and.sum(ind_3).eq.0.) then
      do ii=1,NKILL
        array(ind_1(ii),ind_2(ii),:) = 0.
      end do
    else if (sum(ind_1).eq.0..and.sum(ind_2).ne.0..and.sum(ind_3).ne.0.) then
      do ii=1,NKILL
        array(:,ind_2(ii),ind_3(ii)) = 0.
      end do
    else if (sum(ind_1).ne.0..and.sum(ind_2).eq.0..and.sum(ind_3).ne.0.) then
      do ii=1,NKILL
        array(ind_1(ii),:,ind_3(ii)) = 0.
      end do
    else
      do ii=1,NKILL
        array(ind_1(ii),ind_2(ii),ind_3(ii)) = 0.
      end do
    end if
    
  end subroutine




end module

