module regurize1d_splines_mod
  
  use regurize_splines_LU_mod
  implicit none
  
  private
  
  public  :: regurize1d_1_isplinest_init
  public  :: regurize1d_1_isplinest

  public  :: regurize1d_1_isplines_init
  public  :: regurize1d_1_isplines

  public  :: regurize1d_1_rsplinest_init
  public  :: regurize1d_1_rsplinest

  public  :: regurize1d_1_rsplines_init
  public  :: regurize1d_1_rsplines

  public  :: regurize1d_1_splines_close

  public  :: regurize1d_2_isplinest_init
  public  :: regurize1d_2_isplinest

  public  :: regurize1d_2_isplines_init
  public  :: regurize1d_2_isplines

  public  :: regurize1d_2_rsplinest_init
  public  :: regurize1d_2_rsplinest

  public  :: regurize1d_2_rsplines_init
  public  :: regurize1d_2_rsplines

  public  :: regurize1d_2_splines_close

  public  :: regurize1d_splines_close

  
  real*8, allocatable       :: regspl1d_headerin(:),regspl1d_headeout(:),regspl1d_splngrid(:)
  integer, private                 :: n1in,n1out,n1spl
  real*8, private                    :: p
  
  ! For LU decomposition
  real*8, allocatable     :: regspl1d_F (:,:),regspl1d_out(:)
  real*8, allocatable     :: regspl1d_FI(:,:),regspl1d_MM(:)
  real*8, private         :: DETER
  integer, private        :: CODE,DD
  integer, allocatable    :: regspl1d_INDX(:)

  !!! Interfaces
  interface regurize1d_1_rsplinest_init
    module procedure regurize1d_rsplinest_init
  end interface

  interface regurize1d_1_rsplinest
    module procedure rsplinest1d_1_1d
    module procedure rsplinest1d_1_2d
    module procedure rsplinest1d_1_3d
  end interface

  interface regurize1d_1_rsplines_init
    module procedure regurize1d_rsplines_init
  end interface

  interface regurize1d_1_rsplines
    module procedure rsplines1d_1_1d
    module procedure rsplines1d_1_2d
    module procedure rsplines1d_1_3d
  end interface

  interface regurize1d_1_isplinest_init
    module procedure regurize1d_isplinest_init
  end interface

  interface regurize1d_1_isplinest
    module procedure isplinest1d_1_1d
    module procedure isplinest1d_1_2d
    module procedure isplinest1d_1_3d
  end interface

  interface regurize1d_1_isplines_init
    module procedure regurize1d_isplines_init
  end interface

  interface regurize1d_1_isplines
    module procedure isplines1d_1_1d
    module procedure isplines1d_1_2d
    module procedure isplines1d_1_3d
  end interface




  interface regurize1d_2_isplines_init
    module procedure regurize1d_isplines_init
  end interface

  interface regurize1d_2_isplines
    module procedure isplines1d_1_1d
    module procedure isplines1d_2_2d
    module procedure isplines1d_2_3d
  end interface

  interface regurize1d_2_isplinest_init
    module procedure regurize1d_isplinest_init
  end interface

  interface regurize1d_2_isplinest
    module procedure isplinest1d_1_1d
    module procedure isplinest1d_2_2d
    module procedure isplinest1d_2_3d
  end interface

  interface regurize1d_2_rsplines_init
    module procedure regurize1d_rsplines_init
  end interface

  interface regurize1d_2_rsplines
    module procedure rsplines1d_1_1d
    module procedure rsplines1d_2_2d
    module procedure rsplines1d_2_3d
  end interface

  interface regurize1d_2_rsplinest_init
    module procedure regurize1d_isplinest_init
  end interface

  interface regurize1d_2_rsplinest
    module procedure rsplinest1d_1_1d
    module procedure rsplinest1d_2_2d
    module procedure rsplinest1d_2_3d
  end interface


  interface regurize1d_1_splines_close
    module procedure regurize1d_splines_close
  end interface

  interface regurize1d_2_splines_close
    module procedure regurize1d_splines_close
  end interface

  contains
  
  subroutine regurize1d_rsplinest_init(headerin_in,headeout_in,splngrid_in,p_in)
    real     ::   headerin_in(:), headeout_in(:), splngrid_in(:)
    real     ::   p_in
    real*8   ::   r
    integer  ::   ii, jj
    call regurize1d_splines_close()
    n1in  = size(headerin_in)
    n1out = size(headeout_in)
    n1spl = size(splngrid_in)
    p     = dble(p_in)

    ! Allocate headerIO vectors
    allocate( regspl1d_headerin(n1in )); regspl1d_headerin = 0.; regspl1d_headerin = dble(headerin_in)
    allocate( regspl1d_headeout(n1out)); regspl1d_headeout = 0.; regspl1d_headeout = dble(headeout_in)
    allocate( regspl1d_splngrid(n1out)); regspl1d_splngrid = 0.; regspl1d_splngrid = dble(splngrid_in)
    
    ! Allocate array for forward and inverse operators
    allocate( regspl1d_out(n1out) , regspl1d_F(n1in,n1spl) , regspl1d_FI(n1spl,n1spl) );
    ! Allocate dummy-array for solver data->model
    allocate( regspl1d_MM(n1spl) );
    ! Allocate index array for permutations
    allocate( regspl1d_INDX(n1spl) )
    
    ! Explicitly construct forward operator as matrix
    do jj=1,n1spl
      do ii=1,n1in
        ! See:   P. Wessel, Computers and Geosciences 35 (2009), 1247-1254.
        r        = abs(regspl1d_headerin(ii)-regspl1d_splngrid(jj))
        regspl1d_F(ii,jj) = exp(-p*r) + p*r - 1.
      end do
    end do
    
    write(0,*) 'Initialized regular tensed splines'

  end subroutine
  
  subroutine regurize1d_rsplines_init(headerin_in,headeout_in,splngrid_in)
    real     ::   headerin_in(:), headeout_in(:), splngrid_in(:)
    real*8   ::   r
    integer  ::   ii, jj
    call regurize1d_splines_close()
    n1in  = size(headerin_in)
    n1out = size(headeout_in)
    n1spl = size(splngrid_in)

    ! Allocate headerIO vectors
    allocate( regspl1d_headerin(n1in )); regspl1d_headerin = 0.; regspl1d_headerin = dble(headerin_in)
    allocate( regspl1d_headeout(n1out)); regspl1d_headeout = 0.; regspl1d_headeout = dble(headeout_in)
    allocate( regspl1d_splngrid(n1out)); regspl1d_splngrid = 0.; regspl1d_splngrid = dble(splngrid_in)
    
    ! Allocate array for forward and inverse operators
    allocate( regspl1d_out(n1out) , regspl1d_F(n1in,n1spl) , regspl1d_FI(n1spl,n1spl) );
    ! Allocate dummy-array for solver data->model
    allocate( regspl1d_MM(n1spl) );
    ! Allocate index array for permutations
    allocate( regspl1d_INDX(n1spl) )
    
    ! Explicitly construct forward operator as matrix
    do jj=1,n1spl
      do ii=1,n1in
        ! See:   P. Wessel, Computers and Geosciences 35 (2009), 1247-1254.
        r        = abs(regspl1d_headerin(ii)-regspl1d_splngrid(jj))
        regspl1d_F(ii,jj) = r**3.
      end do
    end do
    
    write(0,*) 'Initialized regular splines'

  end subroutine
  
  subroutine regurize1d_isplinest_init(headerin_in,headeout_in,p_in)
    real     ::   headerin_in(:), headeout_in(:)
    real     ::   p_in
    real*8   :: r
    integer  ::   ii, jj
    call regurize1d_splines_close()
    n1in  = size(headerin_in)
    n1out = size(headeout_in)
    p     = dble(p_in)

    ! Allocate headerIO vectors
    allocate( regspl1d_headerin(n1in )); regspl1d_headerin = 0.; regspl1d_headerin = dble(headerin_in)
    allocate( regspl1d_headeout(n1out)); regspl1d_headeout = 0.; regspl1d_headeout = dble(headeout_in)
    
    ! Allocate array for forward and inverse operators
    allocate( regspl1d_out(n1out) , regspl1d_F(n1in,n1in) , regspl1d_FI(n1in,n1in) );
    ! Allocate dummy-array for solver data->model
    allocate( regspl1d_MM(n1in) );
    ! Allocate index array for permutations
    allocate( regspl1d_INDX(n1in) );
    
    ! Explicitly construct forward operator as matrix
    do jj=1,n1in
      do ii=1,n1in
        ! See:   P. Wessel, Computers and Geosciences 35 (2009), 1247-1254.
        r        = abs(regspl1d_headerin(ii)-regspl1d_headerin(jj))
        regspl1d_F(ii,jj) = exp(-p*r) + p*r - 1.
      end do
    end do

    write(0,*) 'Initialized irregular tensed splines'

  end subroutine
  
  subroutine regurize1d_isplines_init(headerin_in,headeout_in)
    real     ::   headerin_in(:), headeout_in(:)
    real*8   ::   r
    integer  ::   ii, jj
    call regurize1d_splines_close()
    n1in  = size(headerin_in)
    n1out = size(headeout_in)
    
    ! Allocate headerIO vectors
    allocate( regspl1d_headerin(n1in )); regspl1d_headerin = 0.; regspl1d_headerin = dble(headerin_in)
    allocate( regspl1d_headeout(n1out)); regspl1d_headeout = 0.; regspl1d_headeout = dble(headeout_in)
    
    ! Allocate array for forward and inverse operators
    allocate( regspl1d_out(n1out)  , regspl1d_F(n1in,n1in) , regspl1d_FI(n1in,n1in) );
    ! Allocate dummy-array for solver data->model
    allocate( regspl1d_MM(n1in) );
    ! Allocate index array for permutations
    allocate( regspl1d_INDX(n1in) );
    
    ! Explicitly construct forward operator as matrix
    do jj=1,n1in
      do ii=1,n1in
        ! See:   P. Wessel, Computers and Geosciences 35 (2009), 1247-1254.
        r        = abs(regspl1d_headerin(ii)-regspl1d_headerin(jj))
        regspl1d_F(ii,jj) = r**3.
      end do
    end do

    write(0,*) 'Initialized irregular splines'

  end subroutine





  subroutine rsplinest1d_1_1d(datain,datout)
    real     :: datain(:),datout(:)
    integer  :: ii, jj, ij
    real*8   :: r

    regspl1d_FI = 0.
    regspl1d_MM = 0.
    regspl1d_INDX = 0.
    regspl1d_out = 0.

    !Call Solver!
      ! Prepare dubbel-precsisions
      do jj=1,n1spl
        do ii=1,n1spl
          do ij=1,n1in
            regspl1d_FI(ii,jj) = regspl1d_FI(ii,jj) + regspl1d_F(ij,ii)*regspl1d_F(ij,jj)
          end do
        end do
      end do
      do ii=1,n1spl
          do ij=1,n1in
            regspl1d_MM(ii   ) = regspl1d_MM(ii   ) + regspl1d_F(ij,ii)*datain(ij)
          end do
      end do

      ! Call LU decomposition and back-substitution
      call LUDCMP(regspl1d_FI,n1spl,regspl1d_INDX,DD,CODE)
      call LUBKSB(regspl1d_FI,n1spl,regspl1d_INDX,regspl1d_MM     )
    !!

    ! Compute values on regular grid
    do jj=1,n1spl
      do ii=1,n1out
          r = abs(regspl1d_headeout(ii)-regspl1d_splngrid(jj))
          regspl1d_out(ii) = regspl1d_out(ii) + regspl1d_MM(jj)*( exp(-p*r) + p*r - 1. )
      end do
    end do
    datout = real(regspl1d_out)

  end subroutine
  


  subroutine rsplines1d_1_1d(datain,datout)
    real     :: datain(:),datout(:)
    integer  :: ii, jj, ij
    real*8   :: r

    write(0,*) 'Start regular spline regularization'

    regspl1d_FI = 0.
    regspl1d_MM = 0.
    regspl1d_INDX = 0.
    regspl1d_out = 0.

    !Call Solver!
      ! Prepare dubbel-precsisions
      do jj=1,n1spl
        do ii=1,n1spl
          do ij=1,n1in
            regspl1d_FI(ii,jj) = regspl1d_FI(ii,jj) + regspl1d_F(ij,ii)*regspl1d_F(ij,jj)
          end do
        end do
      end do

      do ii=1,n1spl
          do ij=1,n1in
            regspl1d_MM(ii   ) = regspl1d_MM(ii   ) + regspl1d_F(ij,ii)*datain(ij)
          end do
      end do

      ! Call LU decomposition and back-substitution
      call LUDCMP(regspl1d_FI,n1spl,regspl1d_INDX,DD,CODE)
      call LUBKSB(regspl1d_FI,n1spl,regspl1d_INDX,regspl1d_MM     )
    !!

    ! Compute values on regular grid
    do jj=1,n1spl
      do ii=1,n1out
          r = abs(regspl1d_headeout(ii)-regspl1d_splngrid(jj))
          regspl1d_out(ii) = regspl1d_out(ii) + regspl1d_MM(jj)*r**3.
      end do
    end do
    datout = real(regspl1d_out)

  end subroutine
  
  
  
  
  
  subroutine isplinest1d_1_1d(datain,datout)
    real     :: datain(:),datout(:)
    integer  :: ii, jj
    real*8   :: r
    
  !  write(0,*) 'Start irregular tensed spline regularization'

    regspl1d_FI = 0.
    regspl1d_MM = 0.
    regspl1d_INDX = 0.
    regspl1d_out = 0.
    
    !Call Solver!
      ! Prepare dubbel-precsisions
      regspl1d_FI = regspl1d_F
      regspl1d_MM = dble(datain)

      ! Call LU decomposition and back-substitution
      call LUDCMP(regspl1d_FI,n1in,regspl1d_INDX,DD,CODE)
      call LUBKSB(regspl1d_FI,n1in,regspl1d_INDX,regspl1d_MM     )
    !!

    ! Compute values on regular grid
    do jj=1,n1in
      do ii=1,n1out
          r = abs(regspl1d_headeout(ii)-regspl1d_headerin(jj))
          regspl1d_out(ii) = regspl1d_out(ii) + regspl1d_MM(jj)*( exp(-p*r) + p*r - 1. )
      end do
    end do
    datout = real(regspl1d_out)

  end subroutine
  
  
  
  subroutine isplines1d_1_1d(datain,datout)
    real     :: datain(:),datout(:)
    integer  :: ii, jj
    real*8   :: r
    
    !write(0,*) 'Start irregular spline regularization'

    regspl1d_FI = 0.
    regspl1d_MM = 0.
    regspl1d_INDX = 0.
    regspl1d_out = 0.
    
    !Call Solver!
      ! Prepare dubbel-precsisions
      regspl1d_FI = regspl1d_F
      regspl1d_MM = dble(datain)

      ! Call LU decomposition and back-substitution
      call LUDCMP(regspl1d_FI,n1in,regspl1d_INDX,DD,CODE)
      call LUBKSB(regspl1d_FI,n1in,regspl1d_INDX,regspl1d_MM     )
    !!
    
    ! Compute values on regular grid
    do jj=1,n1in
      do ii=1,n1out
          r = abs(regspl1d_headeout(ii)-regspl1d_headerin(jj))
          regspl1d_out(ii) = regspl1d_out(ii) + regspl1d_MM(jj)*r**3.
      end do
    end do
    datout = real(regspl1d_out)

  end subroutine
  
  
  
  
  subroutine isplinest1d_1_2d(datain,datout)
    real     :: datain(:,:),datout(:,:)
    integer  :: jj,n2
    n2 = size(datout,2)
    do jj=1,n2
      call isplinest1d_1_1d(datain(:,jj),datout(:,jj))
    end do

  end subroutine

  subroutine isplines1d_1_2d(datain,datout)
    real     :: datain(:,:),datout(:,:)
    integer  :: jj,n2
    n2 = size(datout,2)
    do jj=1,n2
      call isplines1d_1_1d(datain(:,jj),datout(:,jj))
    end do

  end subroutine

  subroutine isplinest1d_1_3d(datain,datout)
    real     :: datain(:,:,:),datout(:,:,:)
    integer  :: jj,kk,n2,n3
    n2 = size(datout,2)
    n3 = size(datout,3)
    do kk=1,n3
    do jj=1,n2
      call isplinest1d_1_1d(datain(:,jj,kk),datout(:,jj,kk))
    end do
    end do

  end subroutine

  subroutine isplines1d_1_3d(datain,datout)
    real     :: datain(:,:,:),datout(:,:,:)
    integer  :: jj,kk,n2,n3
    n2 = size(datout,2)
    n3 = size(datout,3)
    do kk=1,n3
    do jj=1,n2
      call isplines1d_1_1d(datain(:,jj,kk),datout(:,jj,kk))
    end do
    end do

  end subroutine





  subroutine isplinest1d_2_2d(datain,datout)
    real     :: datain(:,:),datout(:,:)
    integer  :: ii,n1
    n1 = size(datout,1)
    do ii=1,n1
   !   write(0,*) ii
      call isplinest1d_1_1d(datain(ii,:),datout(ii,:))
    end do
  end subroutine

  subroutine isplines1d_2_2d(datain,datout)
    real     :: datain(:,:),datout(:,:)
    integer  :: ii,n1
  !  write(0,*) 'Start irregular spline regularization'
    n1 = size(datout,1)
    do ii=1,n1
    !  write(0,*) ii
      call isplines1d_1_1d(datain(ii,:),datout(ii,:))
    end do
  end subroutine

  subroutine isplinest1d_2_3d(datain,datout)
    real     :: datain(:,:,:),datout(:,:,:)
    integer  :: ii,kk,n1,n3
    n1 = size(datout,1)
    n3 = size(datout,3)
    do kk=1,n3
    do ii=1,n1
      call isplinest1d_1_1d(datain(ii,:,kk),datout(ii,:,kk))
    end do
    end do
  end subroutine

  subroutine isplines1d_2_3d(datain,datout)
    real     :: datain(:,:,:),datout(:,:,:)
    integer  :: ii,kk,n1,n3
    n1 = size(datout,1)
    n3 = size(datout,3)
    do kk=1,n3
    do ii=1,n1
      call isplines1d_1_1d(datain(ii,:,kk),datout(ii,:,kk))
    end do
    end do

  end subroutine




  subroutine rsplinest1d_1_2d(datain,datout)
    real     :: datain(:,:),datout(:,:)
    integer  :: jj,n2
    n2 = size(datout,2)
    do jj=1,n2
      call rsplinest1d_1_1d(datain(:,jj),datout(:,jj))
    end do
  end subroutine

  subroutine rsplines1d_1_2d(datain,datout)
    real     :: datain(:,:),datout(:,:)
    integer  :: jj,n2
    n2 = size(datout,2)
    do jj=1,n2
      call rsplines1d_1_1d(datain(:,jj),datout(:,jj))
    end do
  end subroutine

  subroutine rsplinest1d_1_3d(datain,datout)
    real     :: datain(:,:,:),datout(:,:,:)
    integer  :: jj,kk,n2,n3
    n2 = size(datout,2)
    n3 = size(datout,3)
    do kk=1,n3
    do jj=1,n2
      call rsplinest1d_1_1d(datain(:,jj,kk),datout(:,jj,kk))
    end do
    end do
  end subroutine

  subroutine rsplines1d_1_3d(datain,datout)
    real     :: datain(:,:,:),datout(:,:,:)
    integer  :: jj,kk,n2,n3
    n2 = size(datout,2)
    n3 = size(datout,3)
    do kk=1,n3
    do jj=1,n2
      call rsplines1d_1_1d(datain(:,jj,kk),datout(:,jj,kk))
    end do
    end do
  end subroutine




  subroutine rsplinest1d_2_2d(datain,datout)
    real     :: datain(:,:),datout(:,:)
    integer  :: ii,n1
    n1 = size(datout,1)
    do ii=1,n1
      call rsplinest1d_1_1d(datain(ii,:),datout(ii,:))
    end do
  end subroutine

  subroutine rsplines1d_2_2d(datain,datout)
    real     :: datain(:,:),datout(:,:)
    integer  :: ii,n1
    n1 = size(datout,1)
    do ii=1,n1
      call rsplines1d_1_1d(datain(ii,:),datout(ii,:))
    end do
  end subroutine

  subroutine rsplinest1d_2_3d(datain,datout)
    real     :: datain(:,:,:),datout(:,:,:)
    integer  :: ii,kk,n1,n3
    n1 = size(datout,1)
    n3 = size(datout,3)
    do kk=1,n3
    do ii=1,n1
      call rsplinest1d_1_1d(datain(ii,:,kk),datout(ii,:,kk))
    end do
    end do
  end subroutine

  subroutine rsplines1d_2_3d(datain,datout)
    real     :: datain(:,:,:),datout(:,:,:)
    integer  :: ii,kk,n1,n3
    n1 = size(datout,1)
    n3 = size(datout,3)
    do kk=1,n3
    do ii=1,n1
      call rsplines1d_1_1d(datain(ii,:,kk),datout(ii,:,kk))
    end do
    end do
  end subroutine






  subroutine regurize1d_splines_close()
    if (allocated(regspl1d_headerin)) deallocate( regspl1d_headerin )
    if (allocated(regspl1d_headeout)) deallocate( regspl1d_headeout )
    if (allocated(regspl1d_F)) deallocate( regspl1d_F )
    if (allocated(regspl1d_out)) deallocate(regspl1d_out )
    if (allocated(regspl1d_FI)) deallocate(regspl1d_FI )
    if (allocated(regspl1d_MM)) deallocate( regspl1d_MM )
    if (allocated(regspl1d_INDX)) deallocate( regspl1d_INDX )
    if (allocated(regspl1d_splngrid)) deallocate(regspl1d_splngrid)
  end subroutine


end module
